<?php
$history = <<<EOF
ver.1.01		2021.07.27	メール送信機能を追加。function send_mail追加
ver.1.02		2021.07.28	メール送信のルールを整理。ロックディレクトリの大文字小文字を識別するように修正。
ver.1.03		2021.08.06	関数外で指定した変数が反映されない場合があるのを修正。
ver.1.04		2021.08.10	utf-8以外の文字コードのPHPファイルから呼び出す場合、IDやパスワードが日本語だとうまく動作しないのを修正。
ver.1.05		2022.03.22	若干修正。
EOF;

//////////////////////////// 設定 ////////////////////////////
global $send_mail, $attach_log, $max_log_count, $mail_adress, $from_adress, $xmailer_name;
$send_mail = 1;										// メール送信する
$attach_log = 1;									// メールにログを添付する
$max_log_count = 200;								// 保存するログ件数
$mail_adress = 'hirayama@rkb-cg.com';				// 送信先メールアドレス
$from_adress = 'hitoshi@shade-search.com';			// 送信元メールアドレス
$xmailer_name = 'login.php';						// 送信メールのヘッダに記載されるメーラー名
$use_emergency_unlock = 1;							// 緊急ロック解除を使用する(1=する|0=しない)
$emergency_unlock = '解除用ワード(変更してください)';			// 緊急解除用ワード
//////////////////////////// 終了 ////////////////////////////

global $version, $use_emergency_unlock, $emergency_unlock;
$version = 0;
$history = explode("\n",$history);
foreach ($history as $i) {
	if (preg_match('/ver\.([\d\.]+)/',$i,$matched) ) {
		$ver = $matched[1];
		if ($ver > $version) { $version = $ver ; }
	}
}

function lock_message ($str) {
	$message = '';
	if ($str == 'id_lock') {
		// アカウントがロックされたときのメッセージ
		$message = 
		"このアカウント(!id!)はロックされています。
		!time!までログインできません。
		ブルートフォース攻撃されている可能性があるので、可能ならアカウントの変更をおすすめします";
	} elseif ($str == 'pass_lock') {
		// パスワードがロックされたときのメッセージ
		$message = 
		"このパスワード(!pass!)はロックされています。
		!time!までログインできません。
		リバースブルートフォース攻撃されている可能性があるので、パスワードの変更をおすすめします";
	} elseif ($str == 'ip_lock') {
		// IPアドレスがロックされたときのメッセージ
		$message = 
		"このIPアドレス(!ip!)はロックされています。
		!time!までログインできません。";
	}
	return $message;
}


function login($id,$pass, $crypt_pass, $login_dir='./login', $limit_times=3, $search_sec=600, $lock_sec=3600) {
	global $use_emergency_unlock, $emergency_unlock, $send_mail, $max_log_count;
	$id = mb_convert_encoding($id, 'utf-8', 'ASCII,JIS,UTF-8,EUC-JP,SJIS-WIN,SJIS');
	$pass = mb_convert_encoding($pass, 'utf-8', 'ASCII,JIS,UTF-8,EUC-JP,SJIS-WIN,SJIS');
	$ue_id = urlencode($id);
	$ue_pass = urlencode($pass);
	$ip = $_SERVER['REMOTE_ADDR'];
	$ue_ip = urlencode($ip);
	if (!isset($use_emergency_unlock)) { $use_emergency_unlock = 1; }									// 緊急ロック解除を使用する
	if ($use_emergency_unlock && !$emergency_unlock) { $emergency_unlock = '緊急解除'; }				// 未設定の場合
	if (!$login_dir) { $login_dir = './login'; }
	if (!$limit_times) { $limit_times = 3; }
	if (!$search_sec) { $search_sec = 600; }
	if (!$lock_sec) { $lock_sec = 3600; }
	if (!is_dir($login_dir)) { mkdir($login_dir); }
	if (!file_exists($login_dir . '/index.html')) { file_put_contents($login_dir . '/index.html',"<html>\n<head></head>\n<body></body>\n</html>\n",LOCK_EX); }
	if (!file_exists($login_dir . '/.htaccess')) { file_put_contents($login_dir . '/.htaccess',"deny from all\n",LOCK_EX); }
	$fi_dir = $login_dir . '/fail_id';
	$fp_dir = $login_dir . '/fail_pass';
	$fip_dir = $login_dir . '/fail_ip';
	$approved_ip = $login_dir . '/approve' . $ue_ip;
// 古いディレクトリを整理 ------------------------
	foreach (array($fi_dir,$fp_dir,$fip_dir) as $fdir) {
		if (!is_dir($fdir)) { continue; }
		$tmpdir = opendir($fdir);
		while ($dir = readdir($tmpdir)) {
			if (preg_match('/^\.{1,2}$/',$dir)) { continue; }
			if (is_dir($fdir . '/' . $dir) && filemtime($fdir . '/' . $dir) + intval($lock_sec) < time() ) {
				$tmpdir2 = opendir($fdir . '/' . $dir);
				while ($file = readdir($tmpdir2)) {
					if (preg_match('/^\.{1,2}$/',$file)) { continue; }
					unlink($fdir . '/' . $dir . '/' . $file);
				}
				closedir($tmpdir2);
				rmdir($fdir . '/' . $dir);
			}
		}
		closedir($tmpdir);
	}
	$tmpdir = opendir($login_dir);
	while ($file = readdir($tmpdir)) {
		if (preg_match('/^approve/',$file)) {
			$path = $login_dir . '/' . $file;
			if (is_dir($path) && filemtime($path) + intval($lock_sec) < time() ) {
				rmdir($path);
			}
		}
	}
	closedir($tmpdir);
//-----------------------------------------------
	
	if (isset($use_emergency_unlock) && $use_emergency_unlock && $pass == $emergency_unlock) {
		// ロックされていないIPアドレスからのアクセスの場合、緊急解除ワードを入力するとそのIPアドレスのみロックを無効にするディレクトリを作成する
		if (!is_dir($fip_dir  . '/' . $ue_ip . '_lock') && !is_dir($approved_ip)) {
			mkdir($approved_ip);
			$message = 'ロックを強制解除しました';
			return $message;
		}
	}
	// 大文字小文字を区別するため、_lockのついたディレクトリのリストを作っておく
	foreach (array('fail_id', 'fail_ip', 'fail_pass') as $subdir) {
		if (!is_dir($login_dir . '/' . $subdir)) { continue; }
		$tmpdir = opendir($login_dir . '/' . $subdir);
		while ($file = readdir($tmpdir)) {
			if (!isset($locked_item[$subdir])) { $locked_item[$subdir] = array(); }
			if (preg_match('/_lock$/',$file)) {
				$locked_item[$subdir][] = preg_replace('/_lock$/', '', $file);
			}
		}
		closedir($tmpdir);
	}
	$item_dir = array('id'=>$fi_dir, 'pass'=>$fp_dir, 'ip'=>$fip_dir);
	$item_name = array('id'=>$id, 'pass'=>$pass, 'ip'=>$ip);
	$ue_name = array('id'=>$ue_id, 'pass'=>$ue_pass, 'ip'=>$ue_ip);
	$cgi_name = array('id'=>'bruteforce_attack.cgi', 'pass'=>'reverse_bruteforce_attack.cgi', 'ip'=>'ip_attack.cgi');
	foreach (array('id', 'pass', 'ip') as $item) {
		if (isset($locked_item['fail_' . $item]) && in_array($ue_name[$item],$locked_item['fail_' . $item]) && !($item != 'ip' && is_dir($approved_ip)) ) {
			$message = str_replace("\n","<br />",lock_message($item . '_lock'));
			$message = str_replace('!' . $item . '!',$item_name[$item],$message);
			$message = str_replace('!time!',date("Y/m/d H:i",filemtime($item_dir[$item] . '/' . $ue_name[$item] . '_lock') + $lock_sec),$message);
			return $message; 
		}
		if (is_dir($item_dir[$item] . '/' . $ue_name[$item])) {
			if (filemtime($item_dir[$item] . '/' . $ue_name[$item]) + $search_sec < time()) {
				if (file_exists($item_dir[$item] . '/' . $ue_name[$item] . '/count.dat')) { unlink($item_dir[$item] . '/' . $ue_name[$item] . '/count.dat'); }
				rmdir($item_dir[$item] . '/' . $ue_name[$item]);
			}
		}
	}
	
	if (phpversion() >= 5.5) {
		if (password_verify($pass, $crypt_pass)) {
			$check = 'yes';
		} else {
			$check = 'no';
		}
	} else {
		if (crypt($pass, $crypt_pass) === $crypt_pass) {
			$check = 'yes';
		} else {
			$check = 'no';
		}
	}
	if ($check == 'no') {
		$locked = array();
		$dat = array(time(),$id,$pass);
		foreach (array('REMOTE_ADDR', 'REMOTE_HOST', 'HTTP_REFERER', 'HTTP_USER_AGENT') as $key) {
			if (isset($_SERVER[$key])) {
				$dat[] = $_SERVER[$key];
			} else {
				$dat[] = '';
			}
		}
		if (!$dat[4]) { $dat[4] = gethostbyaddr($dat[3]); }
		foreach (array('id', 'pass', 'ip') as $item) {
			if (!is_dir($item_dir[$item])) {
				mkdir($item_dir[$item]);
				file_put_contents($item_dir[$item] . '/index.html',"<html>\n<head></head>\n<body></body>\n</html>\n",LOCK_EX);
				file_put_contents($item_dir[$item] . '/.htaccess',"deny from all\n",LOCK_EX);
			}
			if (!is_dir($item_dir[$item] . '/' . $ue_name[$item])) { mkdir($item_dir[$item] . '/' . $ue_name[$item]); }
			file_put_contents($item_dir[$item] . '/' . $ue_name[$item] . '/count.dat',1,FILE_APPEND | LOCK_EX);
			if (filesize($item_dir[$item] . '/' . $ue_name[$item] . '/count.dat') >= $limit_times) {
				if (!is_dir($item_dir[$item] . '/' . $ue_name[$item] . '_lock')) {
					mkdir($item_dir[$item] . '/' . $ue_name[$item] . '_lock');
					$locked[$cgi_name[$item]] = 1;
				}
				// ロック中の認証失敗はログに残す
				file_put_contents($login_dir . '/' . $cgi_name[$item], join('<>',$dat) . "\n", FILE_APPEND | LOCK_EX);
			}
		}
		if ($locked) {
			foreach (array('bruteforce_attack.cgi', 'reverse_bruteforce_attack.cgi', 'ip_attack.cgi') as $_) {
				if (!isset($locked[$_]) || !$locked[$_]) { continue; }
				if (!file_exists($login_dir . '/' . $_)) { continue; }
				$attack_log = file($login_dir . '/' . $_);
				if (count($attack_log) > $max_log_count) {
					$past_log = array_splice($attack_log,0,(count($attack_log) - $max_log_count));
					$file_nmb = 1;
					$next_path = preg_replace('/\.cgi$/', '_' . $file_nmb . '.cgi', $login_dir . '/' . $_);
					while (file_exists($next_path)) {
						$past_path = $next_path;
						$file_nmb++;
						$next_path = preg_replace('/\.cgi$/', '_' . $file_nmb . '.cgi', $login_dir . '/' . $_);
					}
					if (!isset($past_path) || count(file($past_path)) >= $max_log_count) { $past_path = $next_path; }
					file_put_contents($past_path, $past_log, FILE_APPEND | LOCK_EX);
					file_put_contents($login_dir . '/' . $_, $attack_log, LOCK_EX);
				}
				if ($send_mail) {
					$count_per_hour = 0;
					foreach (array_reverse($attack_log) as $line) {
						$tmp = explode('<>',$line);
						if ($tmp[0] + $lock_sec > time()) {
							$count_per_hour++;
						} else {
							break;
						}
					}
					if ($count_per_hour > 3) {
						send_mail($login_dir,$_);
						//break;
					}
				}
			}
		}
		return "アカウント、またはパスワードが間違っています";
	} else {
		return 0;
	}	
}

function show_bruteforce_log($login_dir='./login') {
	if (! is_dir($login_dir)) { return; }
	if (file_exists($login_dir . '/bruteforce_attack.cgi')) {
		$bruteforce_log['bruteforce'] = file($login_dir . '/bruteforce_attack.cgi');
	}
	if (file_exists($login_dir . '/reverse_bruteforce_attack.cgi')) {
		$bruteforce_log['reverse_bruteforce'] = file($login_dir . '/reverse_bruteforce_attack.cgi');
	}
	if (file_exists($login_dir . '/ip_attack.cgi')) {
		$bruteforce_log['ip'] = file($login_dir . '/ip_attack.cgi');
	}

	$html = '';
	$current_url = $_SERVER['REQUEST_URI'];
	$url = explode('?',$current_url);
	$tmp = explode('&',$url[1]);
	foreach ($tmp as $_) {
		$tmp2 = explode('=',$_);
		$hash[$tmp2[0]] = $tmp2[1];
	}
	foreach (array('bruteforce', 'reverse_bruteforce', 'ip') as $_) {
		if ($_ == 'bruteforce') {
			$hash['show_bruteforce'] = 1;
		} else {
			$hash['show_bruteforce'] = 0;
		}
		if ($_ == 'reverse_bruteforce') {
			$hash['show_reverse_bruteforce'] = 1;
		} else {
			$hash['show_reverse_bruteforce'] = 0;
		}
		if ($_ == 'ip') {
			$hash['show_ip'] = 1;
		} else {
			$hash['show_ip'] = 0;
		}
		$url2 = array();
		foreach ($hash as $key=>$val) {
			$url2[] = $key . '=' . $val;
		}
		$url2 = join("&amp;",$url2);
		if (isset($_REQUEST['show_' . $_]) && $_REQUEST['show_' . $_]) {
			$html .= "<div><strong>ブルートフォース攻撃のログ($_)</strong></div>\n";
		} else {
			$html .= "<div><a href=\"" . $url[0] . "?$url2\">ブルートフォース攻撃のログ($_)</a></div>\n";
		}
	}
	foreach (array('bruteforce', 'reverse_bruteforce', 'ip') as $_) {
		if (isset($bruteforce_log[$_])) {
			if (isset($_REQUEST['show_' . $_]) && $_REQUEST['show_' . $_]) {
				$index = "<div style=\"display:flex;flex-wrap:wrap;margin:0.3em;align-items:center;\"><div style=\"flex-basis:11em;margin:0.2em;font-size:80%;\">日時</div>\n";
				if ($_ == 'bruteforce') {
					$bold = 'font-weight:bold;';
				} else {
					$bold = '';
				}
				$index .= "<div style=\"flex-basis:10em;margin:0.2em;$bold\">ユーザーID</div>\n";
				if ($_ == 'reverse_bruteforce') {
					$bold = 'font-weight:bold;';
				} else {
					$bold = '';
				}
				$index .= "<div style=\"flex-basis:10em;margin:0.2em;$bold\">パスワード</div>";
				if ($_ == 'ip') {
					$bold = 'font-weight:bold;';
				} else {
					$bold = '';
				}
				$index .= "<div style=\"flex-basis:6em;margin:0.2em;$bold\">アドレス</div>\n";
				$index .= "<div style=\"flex-basis:4em;margin:0.2em;\">ホスト</div><div style=\"flex-basis:10em;margin:0.2em;\">URL</div><div style=\"margin:0.2em;\">エージェント</div></div>\n";
				$html .= $index;
				foreach (array_reverse($bruteforce_log[$_]) as $line) {
					$dat = explode('<>',$line);
					$date = date("Y/m/d H:i:s",$dat[0]);
					$id = $dat[1];
					$password = $dat[2];
					$addr = $dat[3];
					$host = $dat[4];
					$referer = $dat[5];
					$agent = $dat[6];
					$tmp = str_replace('日時',$date,$index);
					$tmp = str_replace('ユーザーID',$id,$tmp);
					$tmp = str_replace('パスワード',$password,$tmp);
					$tmp = str_replace('アドレス',$addr,$tmp);
					$tmp = str_replace('ホスト',$host,$tmp);
					$tmp = str_replace('URL',$referer,$tmp);
					$tmp = str_replace('エージェント',$agent,$tmp);
					$html .= "<hr />\n" . $tmp;
				}
			}
		}
	}
	return "<div style=\"margin:0.5em;\">$html</div>\n";
}

function send_mail($login_dir, $attach) {
	global $mail_adress, $attach_log;

	if (!$login_dir) { $login_dir = './login'; }
	global $from_adress;
	list($url) = explode('?', $_SERVER['HTTP_REFERER']);
	if ($attach == 'reverse_bruteforce_attack.cgi') {
		$comment = "$url\nリバースブルートフォースアタックを受けています。";
		$subject = "リバースブルートフォースアタック警告 ($url)";
	} elseif ($attach == 'ip_attack.cgi') {
		$comment = "$url\nブルートフォースアタックを受けています。IPアドレスがロックされました。";
		$subject = "ブルートフォースアタック警告(IPアドレスロック) ($url)";
	} else {
		$comment = "$url\nブルートフォースアタックを受けています。";
		$subject = "ブルートフォースアタック警告 ($url)";
	}
	$bcc_list = array();
	$bcc_list = array_unique($bcc_list);
	$bcc = join(", ",$bcc_list);
	if ($from_adress) {
		$from = $from_adress;
	} else {
		$from = $mail_adress;
	}
	$from = preg_replace('/,\s?.*$/','',$from);
	$to = $mail_adress;
	$body = '';
	if ($comment) {
		$body .= $comment;
	}
	$file = array();
	if ($attach_log) {
		if (isset($attach)) {
			$file[] = $login_dir . '/' . $attach;
		} else {
			foreach (array('bruteforce_attack.cgi', 'reverse_bruteforce_attack.cgi', 'ip_attack.cgi') as $_) {
				if (file_exists($login_dir . '/' . $_)) {
					$file[] = $login_dir . '/' . $_;
				}
			}
		}
	}
	$sentflag = 0;
	if(SendAttachedMail_login($from, $to, $subject, $body, $file, $bcc)){
		$result = "<div style=\"color:blue\">" . "管理者へ送信しました。</div>\n";
		$admin_sent_file = $login_dir . '/sentmail.cgi';
		file_put_contents($admin_sent_file,time() . "\n", LOCK_EX);
		$sentflag = 1;
	} else {
		$result = "<div style=\"color:red\">メール送信失敗しました。</div>\n";
	}
}


// 複数のファイルを添付してメール送信する。
function SendAttachedMail_login( $from , $to , $subject , $body , &$file , $bcc , $cc = ''){
	global $xmailer_name, $version, $from_adress;
	mb_language( 'ja' );
	mb_internal_encoding( 'ISO-2022-JP' );

	$boundary = "__Boundary__" . uniqid( rand() , true ) . "__";
	$mime = "application/octet-stream";

	$header = "";
	$header .= "From: $from\n";
	if ($cc) {
		$header .= "CC: $cc\n";
	}
	if ($bcc) {
		$header .= "BCC: $bcc\n";
	}
	$header .= "MIME-Version: 1.0\n";
	$header .= "Content-Type: Multipart/Mixed; boundary=\"$boundary\"\n";
	$header .= "Content-Transfer-Encoding: 7bit";
	$mbody = "--$boundary\n";
	$mbody .= "Content-Type: text/plain; charset=ISO-2022-JP\n";
	$mbody .= "Content-Transfer-Encoding: 7bit\n";
	$mbody .= "X-Mailer: $xmailer_name:Version$version\n";
	$mbody .= "\n";
	$mbody .= mb_convert_encoding( $body , 'ISO-2022-JP' , 'auto' );
	$mbody .= "\n";
	for( $i = 0 ; $i < count( $file ) ; $i++ ){
		$filename = mb_encode_mimeheader( mb_convert_encoding( basename( $file[ $i ] ) ,	"ISO-2022-JP" , 'auto' ) );
		$mbody .= "--$boundary\n";
		$mbody .= "Content-Type: $mime; name=\"$filename\"\n";
		$mbody .= "Content-Transfer-Encoding: base64\n";
		$mbody .= "Content-Disposition: attachment; filename=\"$filename\"\n";
		$mbody .= "\n";
		$mbody .= chunk_split( base64_encode(file_get_contents( $file[ $i ] ) ) , 76 ,"\n" );
		$mbody .= "\n";
	}
	$mbody .= "--$boundary--\n";
	// Return-Path の指定をしておかないとスパムメールと判断されて受信できない場合があるようだ。
	// メール送信元ではなく、
	if (preg_match("/<([^>]+)>/",$from,$match)) {
		$from = $match[1];
	}
	list($return) = explode(',',$from);
	$parameter = "-f " . $return;
	if ($from_adress) { $parameter = "-f " . $from_adress; }
	return mail( $to , mb_encode_mimeheader( mb_convert_encoding( $subject , "ISO-2022-JP" , 'auto' )) , $mbody , $header , $parameter);
}

?>