<?php
global $bbs_help;
$explan = "掲示板を作成する
■ファイルアップロード、返信、過去ログ生成、隠しパラメータ送信によるスパム投稿対策、スライドロックによるスパム投稿対策
オプションは[[bbs('lock=1|max_log=100|item=thread')]]のように指定
<h3>指定できるオプション</h3>
<dl><dt>form</dt><dd>form=up（フォームを上に表示）　form=down（フォームを下に表示）</dd></dl>
<dl><dt>item</dt><dd>デフォルトの記事表示順を指定
item=time（投稿順）　item=thread（スレッドごとに表示）</dd></dl>
<dl><dt>max_log</dt><dd>現行ログの保存数。これを超えると過去ログに移動。
例　max_log=50</dd></dl>
<dl><dt>max_past</dt><dd>過去ログに保存する記事数。これを超えると過去ログファイルを新たに作成。
例　max_past=100</dd></dl>
<dl><dt>page_line</dt><dd>1ページに表示する記事数。これを超えると次のページに表示
例　page_line=10</dd></dl>
<dl><dt>lock</dt><dd>スライダで投稿ボタンをロックする　lock=1で表示する
例　lock=1</dd></dl>
<dl><dt>perm_tag</dt><dd>許可するタグ。複数ある場合は;(セミコロン)で区切る。
有効になるのはタグ名だけを<>で囲った場合とその閉じタグだけ。styleなどは指定できない。
例　perm_tag=pre;h1</dd></dl>
<dl><dt>nameless</dt><dd>投稿者名未入力で投稿した場合、表示される名前を指定。'id'にすると、日付とIPアドレスを元にしたIDを表示
例　nameless=id</dd></dl>
<dl><dt>titleless</dt><dd>タイトル未入力で投稿した場合、表示されるタイトルを指定。
例　titleless=タイトルなし</dd></dl>
<dl><dt>hide_bbs</dt><dd>デフォルトでフォームと投稿内容を隠す　hide_bbs=1で隠す
例　hide_bbs=1</dd></dl>
<dl><dt>show_text</dt><dd>添付したtextファイルの内容を表示する　show_text=txt;phpのように表示するテキストファイルの拡張子を指定する。複数ある場合は;(セミコロン)で区切る
例　show_text=txt;log</dd></dl>
";

$bbs_help = $explan;
$format = "[[bbs('lock=1|nameless=id')]]
";
date_default_timezone_set('Asia/Tokyo');
////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function bbs($option = '') {
	global $img_ext,$bbs_help,$end,$script,$new_day,$ng_word;
	global $title_, $writer_,$comment_,$date_,$id,$bbs_dir,$log,$id_path,$slide_lock;
	global $tag_list, $hide_form, $upload_error;
	$tag_list = $perm_tag_list = array();	// タグは一切使用不可に
	if (isset($_REQUEST['hide_form'])) {
		$hide_form = req('hide_form');
		setcookie("bbs_hide_form_" . article_id(), req('hide_form'), time() + 3600*24);
	} elseif (isset($_COOKIE['bbs_hide_form_' . article_id()])) {
		$hide_form = $_COOKIE['bbs_hide_form_' . article_id()];
	}
	if (req('res') || (req('hashed') && req('bbs_pass'))) { $hide_form = 0; }
	if ($option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			$option[$tmp2[0]] = $tmp2[1];
		}
	} else {
		unset($option);
	}
	if (!isset($option['form'])) { $option['form'] = 'up'; }	// フォームの表示位置
	if (!isset($option['item'])) { $option['item'] = 'time'; }	// ログの保存数
	if (!isset($option['lock'])) { $option['lock'] = ''; }	// スライドロック表示
	if (!isset($option['nameless'])) { $option['nameless'] = '名無し'; }	// 投稿者名未記入の場合
	if (!isset($option['titleless'])) { $option['titleless'] = '無題'; }	// タイトル名未記入の場合
	if (!isset($option['hide_bbs'])) { $option['hide_bbs'] = 0; }	// デフォルトですべて隠す
	if (!isset($option['show_text'])) { $option['show_text'] = ''; }
	if (!isset($option['perm_tag'])) { $option['perm_tag'] = ''; }
	$perm_tag_list = explode(';', $option['perm_tag']);
	if ($option['show_text']) {
		global $show_text_file, $txt_ext, $max_text_line;
		$show_text_file = 1;
		$txt_ext = explode(';', $option['show_text']);
		if (isset($option['max_text_line'])) { $max_text_line = $option['max_text_line']; }
	}
	if ($option['lock']) { $slide_lock = 1; } else { $slide_lock = 0; }
	$item = $option['item'];
	if (req('item')) { $item = req('item'); }
	if (!isset($option['max_log'])) { $option['max_log'] = 100; }	// ログの保存数
	if (!isset($option['max_past'])) { $option['max_past'] = 100; }	// 過去ログの最大数
	if (!isset($option['page_line'])) { $option['page_line'] = 10; }	// 1ページあたりの記事数
	$str = '';
	if (req('bbs_help')) {
		$hash = array('plugin'=>'bbs','id'=>$id,'bbs_help'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$str .= "<a href=\"" . script_link($hash,'bbs') . "\">戻る</a>";
		$str .= "<h2 id=\"bbs_help\">bbs.phpのヘルプ</h2>";
		$bbs_help = preg_replace('/>\n+/',">\n",$bbs_help);
		$tmp = explode("\n",$bbs_help);
		foreach ($tmp as $_) {
			$mat = $trans = '';
			if (preg_match('/<dt>([^<]+)<\/dt>/',$_,$mat)) {
				if (isset($mat[1]) && isset($option[$mat[1]])) {
					$trans = " (現在の設定は" . $mat[1] . '=' . $option[$mat[1]] . ')';
				}
				$_ = preg_replace('/<dt>([^<]+)<\/dt>/',"<b>" . $mat[1] . "</b>" . $trans,$_);
			}
			if (!preg_match('/>$/',$_)) {
				$str .= $_ . "<br />\n";
			} else {
				$str .= $_ . "\n";
			}
		}
		$str = str_replace("\n","|n|",$str);
		$str = str_replace("!perm_tag!",join(',',$tag_list),$str);
		return $str;
	}
	$id = article_id();
//	if (req('id') && req('id') != $id) { return; }
	if (!$id) { $id = req('id'); }
	if (!$id) { $id = req('noform'); }
	if (!$id) { $id = req('edit'); }
	if ($id == 'all') { $id = ''; }
	if (!$id) { return; }
	$id_dir = article_dir($id);
	if ($id_dir && !is_dir($id_dir)) { mkdir($id_dir); }
	$bbs_dir = join('/',array($id_dir,'bbs'));
	if (! is_dir($bbs_dir)) { mkdir($bbs_dir); }
	$id_path = join('/',array($id_dir,'bbs','bbs.cgi'));
	$log = array();
	$last = '';
	if (file_exists($bbs_dir . '/bbs_ng_word.cgi')) {
		list($ng_word) = file($bbs_dir . '/bbs_ng_word.cgi');
	}
	if (!isset($ng_word)) { $ng_word = ''; }	// 1ページあたりの記事数
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		$last = end($log);
		$last = rtrim($last);
	}
	if (req('plugin') != 'bbs' && ($option['hide_bbs'] || req('hide_bbs'))) {
		$hash = array('plugin'=>'bbs','id'=>$id);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		if (count($log)) {
			$comstr = count($log) . '件のコメント';
		} else {
			$comstr = 'コメントを投稿する';
		}
		$str .= "<a href=\"" . script_link($hash) . "#bbs\" style=\"font-size:90%;\">$comstr</a>";
		return "<div class=\"notprint\" id=\"bbs_top\">$str</div>\n";
	}
	if (req('show_past')) {
		$file_nmb = 1;
		while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
			$file_nmb++;
		}
		if (req('past_nmb')) {
			$past_nmb = req('past_nmb');
		} else {
			$past_nmb = $file_nmb - 1;
		}
		$past_path = preg_replace('/\.cgi$/','_' . $past_nmb . '.cgi',$id_path);
		if (req('id2')) { $past_path = $bbs_dir . '/' . req('file'); }
		$log = file($past_path);
		$log = array_reverse($log);
		if ($item == 'thread') {
			$thread = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				$line_[$tmp[0]] = $line;
				$ptitle = preg_replace('/^Re:\s*/','',$tmp[2]);
				if (!isset($thread[$ptitle])) { $thread[$ptitle] = array(); }
				array_push($thread[$ptitle],$tmp[0]);
			}
			$new_log = array();
			foreach ($thread as $ptitle=>$val) {
				foreach ($val as $_) {
					$new_log[] = $line_[$_];
				}
			}
			$log = $new_log;
		}
		if (req('id2')) {
			$count = 0;
			foreach ($log as $line) {
				$tmp =explode('<>',$line);
				if ($tmp[0] == req('id2')) {
					$past_nmb = intval($count / $option['page_line']);
					break;
				}
				$count++;
			}
		}
		$hash = array('plugin'=>'bbs','id'=>$id,'show_past'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$indx = "<a href=\"" . script_link($hash) . "\">戻る</a>&nbsp;<strong>過去ログ</strong>&nbsp;";
		$nmb = 1;
		$show_next_id = 0;
		for ($i=$file_nmb-1; $i>=1; $i--) {
			if ($i == $past_nmb) {
				$indx .= "<b>[$nmb]</b> <wbr>\n";
			} else {
				$hash = array('plugin'=>'bbs','id'=>$id,'past_nmb'=>$i,'show_past'=>1);
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				if (req('item')) { $hash['item'] = req('item'); }
				$link = script_link($hash) . "#next_page";
				if (!$show_next_id) {
					$indx .= "<a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . $nmb . "]</a> <wbr>\n";
					$show_next_id = 1;
				} else {
					$indx .= "<a href=\"$link\">[" . $nmb . "]</a> <wbr>\n";
				}
			}
			$nmb++;
		}
		if ($item == 'time') {
			$hash = array('plugin'=>'bbs','id'=>$id,'show_past'=>'1','item'=>'thread');
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$indx .= " <strong style=\"font-size:80%;\">投稿順に表示</strong> <wbr><a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">スレッドごとに表示</a>";
		} else {
			$hash = array('plugin'=>'bbs','id'=>$id,'show_past'=>'1','item'=>'time');
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$indx .= " <a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">投稿順に表示</a> <wbr><strong style=\"font-size:80%;\">スレッドごとに表示</strong>";
		}
		$str .= $indx;
		$com = '';
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			list($idp,$datep,$titlep,$namep,$commentp,$hashed) = $tmp;
			if (isset($tmp[6])) { $rewrite = $tmp[6]; }
			$com .= "<li id=\"bbs_" . $idp . "\"><strong>$titlep</strong>&nbsp;$datep&nbsp;$namep<br />";
			$attach = $attach_str = '';
			$attach_mtime_list = array();
			$tmpdir = opendir($bbs_dir);
			while ($file = readdir($tmpdir)) {
				if (strpos($file,$idp) !== false && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$attach_mtime_list["$bbs_dir/$file"] = filemtime("$bbs_dir/$file");
					if (preg_match('/_(\d+)/', $file, $match)) {
						$nmb = $match[1];
						$attach_nmb[$nmb] = "$bbs_dir/$file";
					}
				}
			}
			closedir($tmpdir);
			for ($i=1;$i<=10;$i++) {
				if (strpos($commentp, "[file$i]") !== false) {
					if (isset($attach_nmb[$i])) {
						$commentp = str_replace('[file' . $i . ']', show_attach($attach_nmb[$i]), $commentp);
						unset($attach_mtime_list["$attach_nmb[$i]"]);
					}
				}
			}
			if ($attach_mtime_list) {
				asort($attach_mtime_list);
				$attach_path_list = array_keys($attach_mtime_list);
				foreach ($attach_path_list as $path) { $attach_str .= show_attach($path); }
			}
			if ($attach_str) { $attach = "<div style=\"display: flex;flex-wrap:wrap;\">$attach_str</div>"; }
			if (req('id2') == $tmp[0] && req('bbs_keyword')) { $commentp = keyword_coloring($commentp,req('bbs_keyword'),'color:#0000cc'); }
			$com_line = preg_split('/<br( \/)?>/',$commentp);
			$tmp_list = array();
			foreach ($com_line as $line) {
				if (preg_match('/^(&gt;|>)/',$line)) {
					$line = "<span style=\"border-radius:5px;padding:0.2em;background-color:#f0fafa;color:#444444;\">$line</span>";
				}
				$tmp_list[] = $line;
			}
			$commentp = join('<br />',$tmp_list);
			$com .= "$commentp\n$attach<hr style=\"margin:1em;\" /></li>\n";
		}
		if ($com) { $com = "<ul>$com</ul>\n"; }
		$str .= $com;
		$indx2 = str_replace('name="next_page"','',$indx);
		$indx2 = str_replace('id="next_page"','',$indx2);
		$str .= $indx2;
		$str = str_replace("\n","|n|",$str);
		return $str;
	}
	if (req('bbs_admin')) {
		return bbs_admin();
	} elseif (req('show_spam')) {
		$hash = array('plugin'=>'bbs');
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		if (req('bbs_admin')) { $hash['bbs_admin'] = req('bbs_admin'); }
		if (req('bbs_admin_login')) { $hash['bbs_admin_login'] = req('bbs_admin_login'); }
		$str .= "<div style=\"display:flex;flex-wrap:wrap;align-items:center;\"><a href=\"" . script_link($hash) . "\">戻る</a>!page_index!</div>\n";
		$spam_log_path = $bbs_dir . '/' . 'bbs_spamlog.cgi';
		$req_page = req('page');
		$req_page = intval($req_page);
		$del_nmb = '';
		foreach ($_REQUEST as $key=>$val) {
			if (preg_match('/^del_spam(\d+)/',$key,$match)) { $del_nmb = $match[1]; }
		}
		$page_list = array();
		for ($i=1; $i < 100;$i++) {
			if (file_exists($bbs_dir . '/' . 'bbs_spamlog_' . $i . '.cgi')) { $page_list[] = $i; }
		}
		if ($req_page) { $spam_log_path = $bbs_dir . '/' . 'bbs_spamlog_' . $req_page . '.cgi'; }
		if (file_exists($spam_log_path)) {
			$spam_log = file($spam_log_path);
			$logmtime = filemtime($spam_log_path);
		} else {
			$spam_log = array();
		}
		if ($del_nmb >= 0 && $del_nmb != '') {
			unset($spam_log[$del_nmb]);
			file_put_contents($spam_log_path, $spam_log, LOCK_EX);
		}
		if (count($spam_log) > 1000) {
			array_shift($spam_log);
			file_put_contents($spam_log_path, $spam_log, LOCK_EX);
		}
		if (isset($logmtime) && $logmtime) { touch($spam_log_path,$logmtime); }
		$spam_log = array_reverse($spam_log);
		$max_per_page = 100;
		$count = 0;
		$line_nmb = count($spam_log);
		$index = "<div style=\"display:flex;flex-wrap:wrap;border:1px solid;<!back_color!>margin-bottom:0.7em;\">";
		$index .= "<div style=\"border:1px solid;flex-grow:1;padding:0.2em;\">時間</div><div style=\"border:1px solid;flex-grow:1;padding:0.2em;\">タイトル</div><div style=\"border:1px solid;flex-grow:1;padding:0.2em;\">投稿者</div><div style=\"border:1px solid;flex-grow:1;padding:0.2em;\">内容</div><div style=\"border:1px solid;flex-grow:1;padding:0.2em;\">拒否</div>";
		$index .= "<div style=\"border:1px solid;flex-grow:1;padding:0.2em;\">IPアドレス</div><div style=\"border:1px solid;flex-grow:1;padding:0.2em;\">ホスト</div><div style=\"border:1px solid;flex-grow:1;padding:0.2em;\">エージェント</div></div>\n";
		$page_index_list = array();
		if ($page_list) {
			$hash['show_spam'] = 1;
			array_unshift($page_list, 0);
			foreach ($page_list as $i) {
				if ($i == $req_page) {
					$page_index_list[] = $i;
				} else {
					$hash['page'] = $i;
					$page_index_list[] = "<a href=\"" . script_link($hash) . "\">" . $i . "</a>";
				}
			}
		}
		foreach ($spam_log as $line) {
			$count++;
			$line_nmb--;
			if ($count % 2) { $back_color = "background-color:#eeeeee;"; } else { $back_color = ''; }
			$tmp = explode('<>',$line);
			$tmp[1] = 1 * $tmp[1];
			if (preg_match('/^\d+$/',$tmp[6])) {
				$block = $tmp[6] . '秒';
			} elseif ($tmp[6]) {
				$block = $tmp[6];
			} else {
				$block = '投稿IDなし';
			}
			if (mb_strlen($tmp[4]) > 140) {
				$comment = jtruncate($tmp[4],140) . '...';
			} else {
				$comment = $tmp[4];
			}
			$comment = str_replace("<","&lt;",$comment);
			$comment = str_replace(">","&gt;",$comment);
			$ind = $index;
			$ind = str_replace('<!back_color!>', $back_color, $ind);
			$ind = str_replace('時間', '<span style="font-size:80%;">' . date("Y/m/d H:i:s", $tmp[1]) . '</span>', $ind);
			$ind = str_replace('タイトル', $tmp[2], $ind);
			$ind = str_replace('投稿者', $tmp[3], $ind);
			$ind = str_replace('内容', $comment, $ind);
			$ind = str_replace('拒否', $block, $ind);
			$ind = str_replace('IPアドレス', $tmp[7], $ind);
			$ind = str_replace('ホスト', $tmp[8], $ind);
			$agent = user_agent($tmp[9]);
			if (is_array($agent)) { $agent = join(',',$agent); }
			if (req('bbs_admin_login')) {
				$del_link = "  <a href=\"" . script_link(array_merge($hash,array('show_spam'=>1,'del_spam' . $line_nmb=>1))) . "\">削除</a>";
			} else {
				$del_link = '';
			}
			$ind = str_replace('エージェント', "<a title=\"" . $tmp[9] . "\">" . $agent . "$del_link</a>", $ind);
			$str .= $ind;
			if (!isset($max['時間'])) { $max['時間'] = 0; }
			if (mb_strwidth(date("Y/m/d H:i:s", $tmp[1])) > $max['時間']) { $max['時間'] = mb_strwidth(date("Y/m/d H:i:s", $tmp[1])); }
			if (!isset($max['タイトル'])) { $max['タイトル'] = 0; }
			if (mb_strwidth($tmp[2]) > $max['タイトル']) { $max['タイトル'] = mb_strwidth($tmp[2]); }
			if (!isset($max['投稿者'])) { $max['投稿者'] = 0; }
			if (mb_strwidth($tmp[3]) > $max['投稿者']) { $max['投稿者'] = mb_strwidth($tmp[3]); }
			if (!isset($max['内容'])) { $max['内容'] = 0; }
			if (mb_strwidth($comment) > $max['内容']) { $max['内容'] = mb_strwidth($comment); }
			if (!isset($max['拒否'])) { $max['拒否'] = 0; }
			if (mb_strwidth($block) > $max['拒否']) { $max['拒否'] = mb_strwidth($block); }
			if (!isset($max['IPアドレス'])) { $max['IPアドレス'] = 0; }
			if (mb_strwidth($tmp[7]) > $max['IPアドレス']) { $max['IPアドレス'] = mb_strwidth($tmp[7]); }
			if (!isset($max['ホスト'])) { $max['ホスト'] = 0; }
			if (mb_strwidth($tmp[8]) > $max['ホスト']) { $max['ホスト'] = mb_strwidth($tmp[8]); }
			if (!isset($max['エージェント'])) { $max['エージェント'] = 0; }
			if (mb_strwidth($agent) > $max['エージェント']) { $max['エージェント'] = mb_strwidth($agent); }
		}
		if ($spam_log && $str) {
			$thead = "<div id=\"bbs_block\">ブロックした投稿</div>";
			$index = str_replace('時間', str_repeat(" ", intval($max['時間']/2)) . '時間' . str_repeat(" ", intval($max['時間']/2)), $index);
			$index = str_replace('タイトル', str_repeat(" ", intval($max['タイトル']/2)) . 'タイトル' . str_repeat(" ", intval($max['タイトル']/2)), $index);
			$index = str_replace('投稿者', str_repeat(" ", intval($max['投稿者'] / 2)) . '投稿者' . str_repeat(" ", intval($max['投稿者'] / 2)), $index);
			$index = str_replace('内容', str_repeat(" ", intval($max['内容'] / 2)) . '内容' . str_repeat(" ", intval($max['内容'] / 2)), $index);
			$index = str_replace('拒否', str_repeat(" ", intval($max['拒否'] / 2)) . '拒否' . str_repeat(" ", intval($max['拒否'] / 2)), $index);
			$index = str_replace('IPアドレス', str_repeat(" ", intval($max['IPアドレス'] / 2)) . 'IPアドレス' . str_repeat(" ", intval($max['IPアドレス'] / 2)), $index);
			$index = str_replace('ホスト', str_repeat(" ", intval($max['ホスト'] / 2)) . 'ホスト' . str_repeat(" ", intval($max['ホスト'] / 2)), $index);
			$index = str_replace('エージェント', str_repeat(" ", intval($max['エージェント'] / 2)) . 'エージェント' . str_repeat(" ", intval($max['エージェント'] / 2)), $index);
			$index = str_replace('flex-grow:1;', 'flex-grow:1;text-align:center;font-weight:bold;', $index);
			$thead .= $index;
			$page_index = '';
			if ($page_index_list) {
				$page_index = "<div style=\"padding-left:1em;display:flex;flex-wrap:wrap;\">\n";
				foreach ($page_index_list as $page) {
					$page_index .= "<div style=\"padding:0.2em;\">$page</div>";
				}
				$page_index .= "</div>\n";
			}
			$str = str_replace('!page_index!', $page_index, $str);
			$str = "<div border=\"1\">$thead$str</div>\n";
		} else {
			$str = str_replace('!page_index!', '', $str);
		}
		$str = str_replace("\n","|n|",$str);
		return $str;
	}
	if (req('bbs_keyword') && req('search')) {
		$hit_list = array();
		$hit_count = 0;
		$result = '';
		$tmp_key = req('bbs_keyword');
		$tmp_key = str_replace('　',' ',$tmp_key);
		$tmp_key = preg_replace('/\s+/',' ',$tmp_key);
		$tmp_key = preg_replace('/^\s+/','',$tmp_key);
		$tmp_key = preg_replace('/\s+$/','',$tmp_key);
		$key_list = explode(' ',$tmp_key);
		$tmpdir = opendir($bbs_dir);
		while ($file = readdir($tmpdir)) {
			$titles = $ids = $tms = array();
			if (preg_match('/^bbs(_\d+)?\.cgi$/',$file)) {
				$log = file($bbs_dir . '/' . $file);
				$log = array_reverse($log);
				$line_nmb = 1;
				foreach ($log as $line) {
					$hit = 1;
					foreach ($key_list as $k) {
						if (!preg_match('/(.{0,30})' . $k . '(.{0,30})/is',$line,$matched)) {
							$hit = 0;
							break;
						}
					}
					if ($hit) {
						$tmp = explode('<>',$line);
						if (!isset($mat[$tmp[0]])) {
							$mat[$tmp[0]] = $matched[0] . " $file $line_nmb";
						} else {
							$mat[$tmp[0]] .= $matched[0] . " $file $line_nmb";
						}
						$titles[$tmp[0]] = $tmp[2];
						$tms[$tmp[0]] = $tmp[1];
						$hit_list[] = $tmp[0];
						$hit_count++;
					}
					$line_nmb++;
				}
				foreach ($titles as $key=>$val) {
					$mat[$key] = str_replace('<','&lt;',$mat[$key]);
					$mat[$key] = str_replace('>','&gt;',$mat[$key]);
					$mat[$key] = keyword_coloring($mat[$key],req('bbs_keyword'),'color:crimson');
					$hash = array('plugin'=>'bbs','noform'=>$id,'sort'=>req('sort'),'id2'=>$key,'bbs_keyword'=>req('bbs_keyword'));
					if (req('item')) { $hash['item'] = req('item'); }
					if ($file != 'bbs.cgi') {
						$hash['show_past'] = 1;
						$hash['file'] = $file;
					}
					$result .= "<li><a href=\"" . script_link($hash) . "#bbs_$key" . "\">[" . $val . "]</a>&nbsp;&nbsp;<br /><span style=\"font-size:80%;\">" . $mat[$key] . "</span></li>\n";
				}
			}
		}
		closedir($tmpdir);
		if ($result) { $result = "<ul>$result</ul>\n"; }
		$result = $hit_count . '件ヒット' . $result;
		$form = bbs_form();
		$str .= $form . $result;
		return $str;
	}
	if ((req('posted') || req('bbs_delete')) && req('plugin') == 'bbs') {
		$req = '';
		foreach ($_REQUEST as $key=>$val) { $req .= "$key → $val\n"; }
		$req .= "--------------------------------------------\n";
		if (!$id) {
			error('このフォームからは投稿できません');	// IDが特定されないフォームからの投稿は拒否
		} else {
			$post_id_file = $bbs_dir . '/' . req('post_id') . '.cgi';
			$spam_str = $spam_mes = array();
			if (! preg_match('/[ぁ-ん]{2}/u', req('comment')) ) {
				$spam_str[] = 'ひらがな無し';
				$spam_mes[] = 'コメントにひらがなが含まれていません';
			}
			if (req('email')) {
				$spam_str[] = 'ダミー';
				$spam_mes[] = '不正な投稿です';
			}
			if (!req('post_id') || !file_exists($post_id_file)) {
				$spam_str[] = 'IDなし';
				$spam_mes[] = '不正な投稿です' . $post_id_file . 'が存在しません';
			}
			if ($option['lock'] && !req('sliderInput')) {
				$spam_str[] = 'slidelock無視';
				$spam_mes[] = 'スライドロックを解除してください';
			}
			if (preg_match('|https?://|',req('title'))) {
				$spam_str[] = 'タイトルにURL';
				$spam_mes[] = 'タイトルにURL';
			}
			preg_match_all('|https?://[0-9a-z\-\./]+:?[0-9]*|',req('comment'), $url);
			if (count($url[0]) > 2) {
				$spam_str[] = 'URL' . count($url[0]) . '個';
				$spam_mes[] = 'URLを減らしてください';
			}
			if (!req('rewrite') && !req('delete') && filemtime($post_id_file) + 8 > time()) {
				$spam_str[] = time() - filemtime($post_id_file) . '秒';
				$spam_mes[] = 'もう少し時間をおいてから投稿してください。';
			} else {
				unlink($post_id_file);
			}
			if (isset($ng_word) && $ng_word && word_chk(req('comment'))) {
				$spam_str[] = '禁止用語';
				$spam_mes[] = '禁止用語が含まれています';
			}
			if (count($spam_str)) {
				spam_log(join('|',$spam_str));
				error(join('<br />',$spam_mes));
			}
			if (!is_dir($bbs_dir)) { mkdir($bbs_dir); }
			$obj = date_create('');
			$tm = date_format($obj, 'Y-m-d H:i:s');
			$comment = req('comment');
			// 改行を削除
			$comment = str_replace("\r\n","\n",$comment);
			$comment = str_replace("\r","\n",$comment);
			$comment = tag_convert($comment);
			$comment = str_replace(">\n",">|n|",$comment);
			$comment = str_replace("\n","<br />",$comment);
			$title = req('title');
			if (req('writer')) {
				$writer = '<strong>' . strip_tags(req('writer')) . '</strong>';
			} else {
				$writer = '';
			}
			$tmp = explode('<>',$last);
			$id2 = $tmp[0];
			for ($i=0;$i<=4;$i++) { if (!isset($tmp[$i])) { $tmp[$i] = ''; } }
			if ($comment == $tmp[4] && $tm == $tmp[1]) {
				//$str .= "コメントが同じなので、キャンセル<br>";
			} else {
				if (preg_match('/^\s?$/',$comment)) { error('コメント内容がありません'); }
				if (!$title || preg_match('/^' . $option['titleless'] . '\d*$/',$title)) {
					foreach ($log as $line) {
						$tmp = explode('<>',$line);
						if (preg_match('/^' . $option['titleless'] . '(\d*)?$/',$tmp[2],$mat)) {
							if ($mat[1] && is_numeric($mat[1])) {
								$title = $option['titleless'] . ($mat[1] + 1);
							} else {
								$title = $option['titleless'] . '1';
							}
						}
					}
					if (!$title) { $title = $option['titleless']; }
				}
				if (!$writer) {
					if ($option['nameless'] == 'id') {
						$writer = user_id();
					} else {
						$writer = $option['nameless'];
					}
				}
				
				// 再編集の場合
				if (req('rewrite') && req('hashed')) {
					$new_log = array();
					foreach ($log as $line) {
						$line = rtrim($line);
						if (strpos($line,'<>') == false) { continue; }
						$tmp = explode('<>',$line);
						if ($tmp[0] == req('id2') && $tmp[5] == req('hashed')) {
							$id2 = $tmp[0];
							if (req('bbs_delete')) {
								$tmpdir = opendir($bbs_dir);
								while ($file = readdir($tmpdir)) {
									if (preg_match('/^' . $id2 . '/',$file)) { unlink($bbs_dir . '/' . $file); }
								}
								closedir($tmpdir);
								continue;
							} else {
								$hashed = $tmp[5];
								// パスワード欄が入力されていたらハッシュを再生成
								if (req('password')) {
									$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
								}
								$line = join('<>',array($id2,$tm,$title,$writer,$comment,$hashed,'再編集'));
							}
						}
						$new_log[] = $line . "\n";
					}
					file_put_contents($id_path,$new_log,LOCK_EX);
				
				// 新規登録の場合
				} else {
					if (req('password')) {
						$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
					} else {
						$hashed = '';
					}
					$id2 = random_str(10);
					$line = join('<>',array($id2,$tm,$title,$writer,$comment,$hashed)) . "\n";
					file_put_contents($id_path,$line,FILE_APPEND | LOCK_EX);
				}
			}
			$upload_error = 0;
			if (! is_dir($bbs_dir)) { mkdir($bbs_dir); }
			$t_name = $_FILES['upfile']["name"];
			$ext = pathinfo($t_name, PATHINFO_EXTENSION);
			$up_path = '';
			$tmp_list = array();
			$tmpdir = opendir($bbs_dir);
			while ($file = readdir($tmpdir)) {
				if (preg_match('/^' . $id2 . '/', $file)) { $tmp_list[] = $file; }
			}
			closedir($tmpdir);
			$tmp_list_str = join('', $tmp_list);
			for ($i=1;$i<=10;$i++) {
				if (strpos($tmp_list_str, $id2 . "_$i") === false) {
					$up_path = $bbs_dir . '/' . $id2 . "_$i" . '.' . $ext;
					break;
				}
			}
			if ($up_path) {
				$uploaded = file_upload('upfile', $up_path);
			}
		}
	} elseif (req('del_file')) {
		if (decrypt(req('bbs_pass'), req('hashed')) == 'yes') {
			$del_file = $bbs_dir . '/' . req('del_file');
			if (file_exists($del_file)) { unlink($del_file); }
			$thumb_file = preg_replace('/(\..{2,4}$)/','thumb$1',$del_file);
			if (file_exists($thumb_file)) { unlink($thumb_file); }
			$oname_file = $del_file . '.oname';
			if (file_exists($oname_file)) { unlink($oname_file); }
		} else {
			error('編集パスワードが違います');
		}
	}
	$log = array();
	if (is_dir($bbs_dir) && file_exists($id_path)) {
		$log = file($id_path);
		if (count($log) > $option['max_log']) {
			$past_log = array_splice($log,0,(count($log) - $option['max_log']));
			$file_nmb = 1;
			while (1) {
				$past_path = preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path);
				if (!file_exists($past_path)) {
					$max_nmb = $file_nmb - 1;
					$past_path = preg_replace('/\.cgi$/','_' . $max_nmb . '.cgi',$id_path);
					break;
				}
				$file_nmb++;
			}
			if (count(file($past_path)) >= $option['max_past']) {
				$past_path = preg_replace('/\.cgi$/','_' . ($max_nmb + 1) . '.cgi',$id_path);
			}
			file_put_contents($past_path,$past_log,FILE_APPEND | LOCK_EX);
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	if ($log) {
		$log = array_reverse($log);	// 新しい順に表示するのに固定
		if ($item == 'thread') {
			$thread = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				$line_[$tmp[0]] = $line;
				$ptitle = preg_replace('/^Re:\s*/','',$tmp[2]);
				if (!isset($thread[$ptitle])) { $thread[$ptitle] = array(); }
				array_push($thread[$ptitle],$tmp[0]);
			}
			$new_log = array();
			foreach ($thread as $ptitle=>$val) {
				foreach ($val as $_) {
					$new_log[] = $line_[$_];
				}
			}
			$log = $new_log;
		}
		$line_nmb = 0;
		if (! req('page')) {
			$page = 0;
		} else {
			$page = req('page');
		}
		$end = intval((count($log) - 1)/$option['page_line']);
		if (req('id2')) {
			$count = 0;
			foreach ($log as $line) {
				$tmp =explode('<>',$line);
				if ($tmp[0] == req('id2')) {
					$page = intval($count / $option['page_line']);
					break;
				}
				$count++;
			}
		}
		$indx = '';
		if ($end > 0) {
			$show_next_id = 0;
			for ($i=0; $i<=$end; $i++) {
				if ($i == $page) {
					$indx .= "<b>[" . ($i+1) . "]</b> <wbr>\n";
				} else {
					$hash = array('plugin'=>'bbs','id'=>$id,'page'=>$i);
					if (req('noform')) { $hash['noform'] = req('noform'); }
					if (!req('noform')) { $hash['noform'] = $id; }
					if (req('sort')) { $hash['sort'] = req('sort'); }
					if (req('item')) { $hash['item'] = req('item'); }
					$link = script_link($hash) . "#next_page";
					if (!$show_next_id) {
						$indx .= "<a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . ($i+1) . "]</a> <wbr>\n";
						$show_next_id = 1;
					} else {
						$indx .= "<a href=\"$link\">[" . ($i+1) . "]</a> <wbr>\n";
					}
				}
			}
		}
		$past_path = preg_replace('/\.cgi$/','_1.cgi',$id_path);
		if (file_exists($past_path)) {
			$hash = array('plugin'=>'bbs','id'=>$id,'show_past'=>1);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('item')) { $hash['item'] = req('item'); }
			$indx .= "<wbr><a href=\"" . script_link($hash) . "\" style=\"white-space:nowrap;\">過去ログ</a>";
		}
		if ($end) {
			if ($item == 'time') {
				$hash = array('plugin'=>'bbs','id'=>$id,'item'=>'thread');
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				$indx .= " <wbr><strong style=\"font-size:80%;\">投稿順に表示</strong> <a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">スレッドごとに表示</a>";
			} else {
				$hash = array('plugin'=>'bbs','id'=>$id,'item'=>'time');
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				$indx .= " <wbr><a href=\"" . script_link($hash) . "\" style=\"font-size:80%;\">投稿順に表示</a> <strong style=\"font-size:80%;\">スレッドごとに表示</strong>";
			}
		}
		if ($indx) { $indx = "<div style=\"padding:0.2em 1em;background-color:#eeeeee;\">$indx</div>\n"; }
		if (req('id2') && req('posted')) {
			$hash = array('plugin'=>'bbs');
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$indx .= "<a href=\"" . script_link($hash) . "\">戻る</a>";
		}
		$str .= $indx . "<ul style=\"list-style-type: none;padding:1em;\">\n";
		$last_title = $back_color = '';
		foreach ($log as $line) {
			if ($line_nmb < $page * $option['page_line'] || $line_nmb >= ($page + 1) * $option['page_line']) {
				$line_nmb++;
				continue;
			}
			$tmp = explode('<>',$line);
			$id2 = $tmp[0];
			$tmp[5] = rtrim($tmp[5]);
			for ($i=0;$i<=4;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			$hash = array('plugin'=>'bbs','id'=>$id,'hashed'=>$tmp[5],'id2'=>$id2);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			} elseif ($id) {
				$hash['noform'] = $id;
			}
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('page')) { $hash['page'] = req('page'); }
			$edit_link = script_link($hash);
			$tmp[5] = rtrim($tmp[5]);
			$ptitle = preg_replace('/^Re:\s*/','',$tmp[2]);
			$style = 'margin:0.3em;';
			if ($item == 'thread' && $last_title && $last_title !== $ptitle) {
				if ($back_color) {
					$back_color = '';
				} else {
					$back_color = "background-color:#eeeeee;";
				}
				$str .= "</ul>\n<ul style=\"list-style-type: none;padding:1em;$back_color\">\n";
			}
			$last_title = $ptitle;
			$new = '';
			if (strtotime($tmp[1]) + 3600*24*$new_day > time()) {
				$new = "<span style=\"color:crimson;font-weight:bold;font-size:80%;\">new</span> ";
			}
			if (req('hashed') && req('hashed') == $tmp[5] && !req('bbs_pass') && !req('posted')) {
				$str .= "<li id=\"bbs_" . $tmp[0] . "\" style=\"$style\">";
			} else {
				$str .= "<li id = \"bbs_" . $tmp[0] . "\" style=\"$style\">";
			}
			$str .= "$new<strong>" . $tmp[2] . "</strong>&nbsp;<span style=\"font-size:80%;\">" . $tmp[1] . "</span> " . $tmp[3];
			$hash = array('plugin'=>'bbs','id'=>$id,'id2'=>$id2,'res'=>1);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			} elseif ($id) {
				$hash['noform'] = $id;
			}
			if (req('sort')) { $hash['sort'] = req('sort'); }
			if (req('page')) { $hash['page'] = req('page'); }
			if (req('item')) { $hash['item'] = req('item'); }
			$res_link = script_link($hash);
			$str .= "&nbsp;&nbsp;<a href=\"$res_link\">返信</a>";
			if ($tmp[5]) { $str .= "&nbsp;&nbsp;<a href=\"$edit_link#bbs_$id2\">編集</a>\n"; }
			$str .= "<br />\n";
			$mod_link = '';
			if (req('hashed') && req('hashed') == $tmp[5] && !req('bbs_pass') && !req('posted')) {
				$hash = array('plugin'=>'bbs','id'=>$id,'hashed'=>req('hashed'),'id2'=>$id2);
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				if (req('page')) { $hash['page'] = req('page'); }
				$mod_link .= script_form_file($hash,'bbs');
				$mod_link .= "&nbsp;&nbsp;<span style=\"font-size:80%;color:#0066dd;\">編集パスワードを入力してください</span>&nbsp;<input type=\"text\" name=\"bbs_pass\" value=\"\" style=\"width:140px;\" /><input id=\"bbs\" type=\"submit\" value=\"編集\" />";
				$mod_link .= "</form>\n";
			} elseif (req('hashed') && req('hashed') == $tmp[5] && req('bbs_pass') && ! password_verify(req('bbs_pass'),req('hashed'))) {
				if ($tmp[5]) { $mod_link .= "&nbsp;<span style=\"color:crimson\">パスワードが違います</span>"; }
			}
			$str .= "$mod_link";
			if (req('id2') == $tmp[0] && req('bbs_keyword')) { $tmp[4] = keyword_coloring($tmp[4],req('bbs_keyword'),'background-color:#998822'); }
			if ($perm_tag_list) {
//				$ptn = '/&lt;(\/?(' . join('|',$perm_tag_list) . '))&gt;/';
//				$ptn2 = '<$1>';
//				$tmp[4] = preg_replace($ptn,$ptn2,$tmp[4]);
				$tmp[4] = show_tag($tmp[4],$perm_tag_list);
			}
			$tmp2 = explode('<br />',$tmp[4]);
			$tmp_list = array();
			foreach ($tmp2 as $line) {
				if (preg_match('/^(&gt;|>)/',$line)) {
					$line = "<span style=\"border-radius:5px;padding:0.2em;background-color:#f0fafa;color:#444444;\">$line</span>";
				}
				$tmp_list[] = $line;
			}
			$str .= join('<br />',$tmp_list);
			$attach_str = '';
			$attach_path_list = $attach_mtime_list = array();
			$tmpdir = opendir($bbs_dir);
			while ($file = readdir($tmpdir)) {
				if (preg_match('/^' . $id2 . '/',$file) && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$attach_mtime_list["$bbs_dir/$file"] = filemtime("$bbs_dir/$file");
					if (preg_match('/_(\d+)/', $file, $match)) {
						$nmb = $match[1];
						$attach_nmb[$nmb] = "$bbs_dir/$file";
					}
				}
			}
			closedir($tmpdir);
			for ($i=1;$i<=10;$i++) {
				if (strpos($str, "[file$i]") !== false) {
					if (isset($attach_nmb[$i])) {
						$str = str_replace('[file' . $i . ']', show_attach($attach_nmb[$i]), $str);
						unset($attach_mtime_list[$attach_nmb[$i]]);
					}
				}
			}
			if ($attach_mtime_list) {
				asort($attach_mtime_list);
				$attach_path_list = array_keys($attach_mtime_list);
				foreach ($attach_path_list as $path) {
					$attach_str .= show_attach($path);
				}
			}
			if ($attach_str) {
				$attach_str = "<div style=\"display: flex;flex-wrap:wrap;\">$attach_str</div>";
				$str .= $attach_str;
			}
			$str .= "<hr style=\"margin:1em;\" />\n</li>\n";
			$comment_[$tmp[5]] = $tmp[4];
			$title_[$tmp[5]] = $tmp[2];
			$writer_[$tmp[5]] = $tmp[3];
			$date_[$tmp[5]] = $tmp[1];
			$line_nmb++;
		}
		$str .= "</ul>\n";
		$indx2 = str_replace('name="next_page"','',$indx);
		$indx2 = str_replace('id="next_page"','',$indx2);
		$str .= $indx2;
	}
	if ($hide_form) {
		$link = $script . "?plugin=bbs";
		foreach (array('id','page','sort','item','noform') as $key) {
			if (req($key)) { $link .= "&amp;{$key}=" . req($key); }
		}
		$link .= "&amp;hide_form=0";
	}
	$form = bbs_form();
	$str = str_replace("\n","|n|",$str);
	$vars = get_defined_vars();
	if (!isset($option['form']) || !$option['form'] || $option['form'] == 'up') {
		return "<div id=\"bbs\">\n" . $form . $str . "</div>\n";
	} elseif ($option['form'] == 'down') {
		return "<div id=\"bbs\">\n" . $str . $form . "</div>\n";
	}
}


function show_attach($path) {
	global $img_ext, $show_dlc, $show_text_file, $txt_ext;
	$attach_str = '';
	$ext = pathinfo($path,PATHINFO_EXTENSION);
	$nmb = '';
	if (preg_match('/_(\d+)/', $path, $match)) { $nmb = $match[1]; }
	if (in_array($ext,$img_ext)) {
		list($image_w, $image_h) = getimagesize($path);
		$width = 500;
		$proportion = $image_w / $image_h;
		$height = $width / $proportion;
		//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
		if($proportion < 1){
			$height = $width;
			$width = $width * $proportion;
			$width = intval($width * 0.8);
			$height = intval($height * 0.8);
		}
		if ($width > $image_w) { $width = $image_w; }
		if (file_exists($path . '.oname')) {
			$title_name = file_get_contents($path . '.oname');
		} else {
			$title_name = basename($path);
		}
		$dl = '';
		if (file_exists($path . '.count')) { $dl = " title=\"" . filesize($path . '.count') . "dl\""; }
		$attach_str .= "<div style=\"padding:3px;\"><img src=\"$path\" width=\"$width\" alt=\"" . basename($path) . "\" title=\"" . $title_name . "\" onclick=\"cmanImgPop(this,'')\" /></div>\n";
	} else {
		$oname = $path . '.oname';
		$org = $path;
		if (file_exists($oname)) { list($org) = file($oname); }
		$sjis_org = mb_convert_encoding($org,'SJIS','UTF-8');
		$hash = array('mode'=>'download', 'file'=>$path, 'name'=>urlencode($sjis_org));
		$link = script_link($hash);
		$dl = '';
		if (file_exists($path . '.count')) { $dl = "&nbsp;" . filesize($path . '.count') . 'dl'; }
		$o_ext = $ext;
		if (file_exists($path . '.oname')) {
			$o_name = file_get_contents($path . '.oname', FILE_IGNORE_NEW_LINES);
			preg_match('/\.(.{3,4}$)/', $o_name, $match);
			if (isset($match[1])) { $o_ext = $match[1]; }
		}
		if ($show_text_file && preg_grep('/' . $o_ext . '/i',$txt_ext)) {
			$txt_str = "<div><pre>!<$path>!</pre></div>\n";
		} else {
			$txt_str = '';
		}
		$attach_str .= "<div style=\"padding:3px;\"><div><a href=\"$link\"><img src=\"./img/clip.gif\" alt=\"$org\" />$org</a>  $dl</div>$txt_str</div>\n";
	}
	$attach_str = show_text($attach_str);
	return($attach_str);
}


function show_text($html) {
	global $max_text_line;
	if (!isset($max_text_line)) { $max_text_line = 100; }
	preg_match_all('/!<([^<>]+)>!/', $html, $match_list);
	if ($match_list[1]) {
		foreach ($match_list[1] as $match) {
			if (!file_exists($match)) { continue; }
			$cont = file($match, FILE_IGNORE_NEW_LINES);
			if ($max_text_line && count($cont) > $max_text_line) {
				$cont = array_slice($cont, 0, $max_text_line);
				$cont[] = ".......................";
			}
			$cont = join("\n", $cont);
			$code = mb_detect_encoding($cont, "JIS, eucjp-win, sjis-win", "utf-8");
			if ($code && $code != 'utf-8') { $cont = mb_convert_encoding($cont, 'utf-8', $code); }
			$cont = str_replace('<', '&lt;', $cont);
			$cont = str_replace('>', '&gt;', $cont);
			$html = preg_replace('|!<' . $match . '>!|', $cont, $html);
		}
	}
	return($html);
}


function word_chk($str) {
	global $ng_word;
	$ng_word_list = explode(',',$ng_word);
	$hit = 0;
	foreach ($ng_word_list as $word) {
		if (preg_match('/' . $word . '/',$str)) {
			$hit = 1;
			break;
		}
	}
	return $hit;
}

function bbs_admin() {
	global $bbs_dir,$str,$log,$id_path,$id,$id_path,$img_ext;
	$login_time = 30;
	$mes = '';
	if (! file_exists($bbs_dir)) { mkdir($bbs_dir); }
	if (! file_exists($bbs_dir. '/login')) { mkdir($bbs_dir. '/login'); }
	$login_dir = $bbs_dir. '/login';
	$tmpdir = opendir($bbs_dir);
	$file_list = array();
	while ($file = readdir($tmpdir)) {
		if (!preg_match('/^\.{1,2}$/',$file)) {
			$file_list[] = $file;
		}
	}
	closedir($tmpdir);
	$tmpdir = opendir($login_dir);
	while ($file = readdir($tmpdir)) {
		if (preg_match('/^\w{10}_/',$file) && filemtime($login_dir . '/' . $file) + 60 * $login_time < time()) {
			unlink($login_dir . '/' . $file);
		}
	}
	closedir($tmpdir);
	$hash = array();
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^bbs_admin/',$key)) { continue; }
		if (preg_match('/^(comment_|mod_|del_|pass)/',$key)) { continue; }
		$hash[$key] = req($key);
	}
	$file_nmb = 1;
	while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
		$file_nmb++;
	}
	if (req('past_nmb')) { $past_nmb = req('past_nmb'); }
	if (isset($past_nmb)) {
		$past_path = preg_replace('/\.cgi$/','_' . $past_nmb . '.cgi',$id_path);
		$id_path = $past_path;
		$log = file($past_path);
	}
	$str .= "<a href=\"" . script_link($hash,'bbs') . "\">戻る</a>";
	$hash['bbs_admin'] = 1;
	if (req('bbs_admin_login')) {
		$hash['bbs_admin_login'] = req('bbs_admin_login');
		$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash,'bbs') . "\">再読み込み</a>";
	}
	if (!req('bbs_admin_login')) {
		if (! req('pass')) {
			$hash = array();
			foreach (array_keys($_REQUEST) as $key) { $hash[$key] = req($key); }
			$str .= script_form($hash,'bbs');
			if (isset($_COOKIE['bbs_admin_pass'])) {
				$cpass = $_COOKIE['bbs_admin_pass'];
			} else {
				$cpass = '';
			}
			$str .= "<input type=\"password\" name=\"pass\" value=\"$cpass\" size=\"12\">";
			$str .= " <input type=\"submit\" name=\"login\" value=\"ログイン\">";
			$str .= "</form>\n";
			return $str;
		} else {
			global $crypt_pass, $cookietime;
			if (decrypt(req('pass'), $crypt_pass) === 'no') {
				error("パスワードが認証できません");
			} else {
				$login_id = random_str(10);
				$bbs_admin_login = $hash['bbs_admin_login'] = $login_id;
				file_put_contents(join('/',array($login_dir, $login_id . '_' . $_SERVER['SERVER_NAME'] . '.cgi')),'',LOCK_EX);
				// クッキーの場合、エポック時間はどうなるのか？
				setcookie("bbs_admin_pass", req('pass'), time() + $cookietime * 3600 * 24);
				setcookie("bbs_cpass", req('pass'), time() + 3600*24);		// アクセス権限を管理者レベルにするためのクッキー
			}
			$hash['pass'] = '';
		}
	} else {
		$login_path = join('/',array($login_dir, req('bbs_admin_login') . '_' . $_SERVER['SERVER_NAME'] . '.cgi'));
		$lhash = array('plugin'=>'bbs','id'=>req('id'),'noform'=>req('noform'),'sort'=>req('sort'),'bbs_admin'=>1);
		$relogin = script_link($lhash,'bbs');
		if (! file_exists($login_path) ) {
			error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
		} else {
			if (filemtime($login_path) + 60 * $login_time < time()) {
				unlink($login_path);
				error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
			} else {
				file_put_contents($login_path,'',LOCK_EX);
			}
		}
	}
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^del_(\w+$)/',$key,$match)) {
			$del_id = $match[1];
			$new_log = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				if ($tmp[0] != $del_id) {
					$new_log[] = $line;
				} else {
					$mes .= '<div><strong>[' . $tmp[2] . ']</strong> の記事を削除しました。</div>';
				}
			}
			$log = $new_log;
			file_put_contents($id_path,$log,LOCK_EX);
			$del_files = preg_grep('/^' . $del_id . '/',$file_list);
			foreach ($del_files as $file) {
				if (unlink("$bbs_dir/$file")) {
					$mes .= '<div><strong>' . "$bbs_dir/$file" . '</strong> を削除しました。</div>';
				}
			}
			break;
		} elseif (preg_match('/^mod_(\w+$)/',$key,$match)) {
			$mod_id = $match[1];
			$new_log = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				if ($tmp[0] == $mod_id) {
					$tmp[4] = req('comment_' . $mod_id);
					$tmp[4] = str_replace("\r\n","\n",$tmp[4]);
					$tmp[4] = str_replace("\r","\n",$tmp[4]);
					$tmp[4] = str_replace("\n",'<br />',$tmp[4]);
					$line = join('<>',$tmp);
					$mes .= '<strong>[' . $tmp[2] . ']</strong> の記事を修正しました。';
				}
				$new_log[] = $line;
			}
			$log = $new_log;
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	if (file_exists($bbs_dir . '/' . 'bbs_spamlog.cgi')) {
		$hash = array('plugin'=>'bbs','id'=>$id,'show_spam'=>1);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		if (req('bbs_admin_login')) { $hash['bbs_admin_login'] = req('bbs_admin_login'); }
		if (isset($bbs_admin_login) && $bbs_admin_login) { $hash['bbs_admin_login'] = $bbs_admin_login; }
		$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash) . "#bbs_block\">拒否投稿</a>";
	}
	if (!isset($bbs_admin_login) || !$bbs_admin_login) { $bbs_admin_login = req('bbs_admin_login'); }
	$hash = array('plugin'=>'bbs', 'id'=>$id, 'bbs_admin'=>1,'edit_ng'=>1, 'bbs_admin_login'=>$bbs_admin_login);
	if (req('noform')) { $hash['noform'] = req('noform'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }
	$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash) . "#bbs_block\">NGワードを編集</a>";
	$indx = '';
	if (req('edit_ng')) {
		$ng_path = $bbs_dir . '/bbs_ng_word.cgi';
		if (req('edit_ng_post')) { file_put_contents($ng_path,req('ng_word'),LOCK_EX); }
		$hash_ng = array('plugin'=>'bbs','id'=>$id,'bbs_admin'=>req('bbs_admin'),'bbs_admin_login'=>$bbs_admin_login,'edit_ng'=>1);
		$str .= "<div style=\"margin:0.5em;\">\n";
		$str .= script_form($hash);
		$ng_path = $bbs_dir . '/bbs_ng_word.cgi';
		if (file_exists($ng_path)) {
			list($ng_word) = file($ng_path);
		} else {
			$ng_word = '';
		}
		$str .= "<div><input type=\"submit\" name=\"edit_ng_post\" value=\"編集する\" /></div>\n";
		$width = mb_strwidth($ng_word);
		if ($width < 10) { $width = 10; }
		if ($width > 80) {
			$str .= "<div>NGワード<br /><textarea name=\"ng_word\" rows=\"2\" style=\"width:100%;\">$ng_word</textarea></div>\n";
		} else {
			$style = " style=\"width:" . (intval($width/2) + 2) . "em;\"";
			$str .= "<div>NGワード <input type =\"text\" name=\"ng_word\"$style value=\"$ng_word\" /></div>\n";
		}
		$str .= "</div>\n";
		return $str;
	}
	$hash_i = array('plugin'=>'bbs','id'=>$id,'past_nmb'=>'','bbs_admin'=>req('bbs_admin'),'bbs_admin_login'=>$bbs_admin_login);
	if (req('noform')) { $hash_i['noform'] = req('noform'); }
	if (req('sort')) { $hash_i['sort'] = req('sort'); }
	if (req('item')) { $hash_i['item'] = req('item'); }
	if (isset($past_nmb)) {
		$link = script_link($hash_i);
		$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link\">現行ログ</a></div>\n";
	} else {
		$indx .= "<div style=\"padding:0.1em;\"><b>現行ログ</b></div>\n";
	}
	$indx .= "<div style=\"padding:0.1em;\">　過去ログ</div>\n";
	$nmb = 1;
	$show_next_id = 0;
	for ($i=$file_nmb-1; $i>=1; $i--) {
		if (isset($past_nmb) && $i == $past_nmb) {
			$indx .= "<div style=\"padding:0.1em;\"><b>[$nmb]</b></div>\n";
		} else {
			$hash_i['past_nmb'] = $i;
			//$link = script_link($hash_i) . "#next_page";
			$link = script_link($hash_i);
			if (!$show_next_id) {
				$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . $nmb . "]</a></div>\n";
				$show_next_id = 1;
			} else {
				$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link\">[" . $nmb . "]</a></div>\n";
			}
		}
		$nmb++;
	}
	$str .= "<div style=\"display:flex;flex-wrap:wrap;\">$indx<div style=\"padding:0.1em;margin-left:auto;\">ログ数:" . count($log) . "</div>\n</div>";
	$str .= "<div style=\"color:crimson\">$mes</div>\n";
	$hash['show_spam'] = 0;
	$hash['bbs_admin'] = 1;
	$hash['edit_ng'] = 0;
	if (req('bbs_admin_login')) { $hash['bbs_admin_login'] = req('bbs_admin_login'); }
	if (req('past_nmb')) { $hash['past_nmb'] = req('past_nmb'); }
	$str .= script_form($hash);
	$str .= "<div>\n";
	$hash['bbs_admin'] = 1;
	$count = 0;
	foreach (array_reverse($log) as $line) {
		$count++;
		$tmp = explode('<>',$line);
		$aid = $tmp[0];
		$attach = preg_grep('/^' . $aid . '/',$file_list);
		if ($attach) {
			$test = join('<>',$attach);
		} else {
			$test = '';
		}
		$comment = $tmp[4];
		$comment = str_replace('<br />',"\n",$comment);
		if ($count % 2) {
			$backcol = "background-color:#dddddd;";
		} else {
			$backcol = "";
		}
		$str .= "<div style=\"display:flex;flex-wrap:wrap;align-items:flex-start;padding:0.2em;$backcol\">";
		$str .= "<div style=\"padding:0.2em;\"><textarea name=\"comment_" . $tmp[0] . "\" cols=\"40\" rows=\"2\" style=\"width:100%;\">" . $comment . "</textarea></div>";
		$str .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"mod_" . $tmp[0] . "\" value=\"修正\" style=\"font-size:80%;\"></div>";
		$hash['del_' . $tmp[0]] = 1;
		$str .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"del_" . $tmp[0] . "\" value=\"削除\" style=\"font-size:80%;\"></div>";
		$atc_str = '';
		foreach ($attach as $atc) {
			if (preg_match('/thumb\./',$atc) || preg_match('/\.(oname|count)$/',$atc)) {
				continue;
			}
			$oname_file = $atc . '.oname';
			if (in_array($oname_file,$file_list)) {
				$oname_path = "$bbs_dir/" . $oname_file;
				$oname = file_get_contents($oname_path,);
				$oname_str = " title=\"$oname\"";
			} else {
				$oname_str = $oname = '';
			}
			$ext = pathinfo($atc,PATHINFO_EXTENSION);
			if (in_array($ext,$img_ext) && !preg_match('/thumb\./',$atc)) {
				$thumb_file = preg_replace('/(\..{2,4}$)/','thumb$1',$atc);
				$thumb_path = "$bbs_dir/" . $thumb_file;
				if (in_array($thumb_file,$file_list)) {
				//if (file_exists($thumb_path)) {
					$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"$thumb_path\"$oname_str /></div>\n";
				} else {
					$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"$bbs_dir/$atc\"$oname_str /></div>\n";
				}
			} else {
				$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"./img/clip.gif\"$oname_str /></div>\n";
			}
		}
		$str .= "<div style=\"display:flex;\">$atc_str</div>";
		$str .= "<div style=\"display:flex;flex-wrap:wrap; margin-left:auto;\"><div style=\"padding:0.2em;\">" . $tmp[2] . "</div><div style=\"padding:0.2em;\">" . $tmp[3] . "</div><div style=\"font-size:80%;padding:0.2em;\">" . $tmp[1] . "</div></div>\n";

		unset($hash['del_' . $tmp[0]]);
		$str .= "</div>\n";
	}
	$str .= "</div>\n";
	$str .= "</form>\n";
	$str = str_replace("\n","|n|",$str);
	return $str;
}


function bbs_form() {
	global $title_, $writer_,$comment_,$date_,$id,$bbs_dir,$log,$end,$id_path,$slide_lock,$img_ext,$script,$hash,$hide_form,$upload_error;
	if (!file_exists($bbs_dir)) { mkdir($bbs_dir); }
	$tenpu_list = array();
	$tmpdir = opendir($bbs_dir);
	while ($file = readdir($tmpdir)) {
		if (req('id2') && preg_match('/^' . req('id2') . '/',$file)) {
			if (!preg_match('/thumb\./',$file) && !preg_match('/\.oname/',$file)) {
				$tenpu_list[] = $file;
				$tenpu_mod_list[$file] = filemtime("$bbs_dir/$file");
			}
		}
		if (! preg_match('/^\w{12}\.cgi$/',$file)) { continue; }
		if (filemtime($bbs_dir . '/' . $file) < time() - 60 * 20) {
			// 古いIDファイル(作成から20分経過)は削除
			unlink($bbs_dir . '/' . $file);
		}
	}
	closedir($tmpdir);
	if (isset($tenpu_mod_list)) {
		asort($tenpu_mod_list);
		$tenpu_list = array_keys($tenpu_mod_list);
	}
	$title = $writer = '';
	$comment = '';
	$post_id = random_str(12);
	$hash = array('plugin'=>'bbs','id'=>$id);
	if (req('id2') && req('bbs_pass') && !req('posted')) { $hash['id2'] = req('id2'); }
	if (req('noform')) {
		$hash['noform'] = req('noform');
	} elseif (req('edit')) {
		$hash['noform'] = req('edit');
	}
	if (req('page')) { $hash['page'] = req('page'); }
	if (req('item')) { $hash['item'] = req('item'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	$hash['page'] = 0;
	if ($slide_lock) {
		$form = "<div id=\"bbs\" class=\"notprint\">\n" . script_form_file($hash,'bbs','slidelock');
	} else {
		$form = "<div id=\"bbs\" class=\"notprint\">\n" . script_form_file($hash,'bbs');
	}
	if (!$hide_form && isset($log) && $log) {
		$link = $script . "?plugin=bbs";
		foreach ($_REQUEST as $key=>$val) {
			if ($key != 'posted' && $key != 'hide_form' && $key != 'plugin' && $key != 'hashed' && $key != 'id2' && $key != 'res' && $key != 'comment') {
				$link .= "&amp;{$key}=$val";
			}
		}
		$link .= "&amp;hide_form=1";
		$form .= "<div style=\"padding-left:1em;\"><a href=\"$link#bbs\">■フォームを隠す</a></div>\n";
	}
	$rewrite = 0;
	if (req('hashed') && req('bbs_pass')) {
		if (password_verify(req('bbs_pass'),req('hashed'))) {
			$comment = $comment_[req('hashed')];
			$title = $title_[req('hashed')];
			$writer = $writer_[req('hashed')];
			$form .= "<input type=\"hidden\" name=\"rewrite\" value=\"1\" />\n";
			$form .= "<input type=\"hidden\" name=\"hashed\" value=\"" . req('hashed') . "\" />\n";
			$rewrite = 1;
		}
	} elseif (req('res')) {
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			if ($tmp[0] == req('id2')) {
				$title = $tmp[2];
				$comment = $tmp[4];
				if (!preg_match('/^Re:/',$title)) { $title = "Re:" . $title; }
				$tmp2 = explode('<br />',$comment);
				$tmp_ar = array();
				foreach ($tmp2 as $_) {
					$_ = preg_replace('/\[file\d+\]/', '', $_);
					$tmp_ar[] = '&gt;' . $_;
				}
				$comment = join('<br />',$tmp_ar);
				break;
			}
		}
	}
	$form .= "<input type=\"hidden\" name=\"post_id\" value=\"" . $post_id . "\" />\n";
	if (!file_exists($bbs_dir . '/' . $post_id . '.cgi')) {
		file_put_contents($bbs_dir . '/' . $post_id . '.cgi','',LOCK_EX);
	}
	$comment = str_replace("<br />","|n|",$comment);
	if ($rewrite) {
		$del_button = "&nbsp;&nbsp;&nbsp;<input id=\"delete\" type=\"submit\" name=\"bbs_delete\" value=\"削除\" />";
	} else {
		$del_button = '';
	}
	$hash = array('plugin'=>'bbs','id'=>$id);
	if (req('noform')) {
		$hash['noform'] = req('noform');
	} elseif (req('edit')) {
		$hash['noform'] = req('edit');
	}
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }

	///////////////// 調整中
	$form .= "<div style=\"padding:0.5em;display: flex;flex-wrap:wrap;\">\n";
	$help_link = "<wbr><a href=\"" . script_link($hash,'bbs') . "&amp;bbs_help=1#bbs_help\">ヘルプ</a>";
	$form .= "<div style=\"padding:0.3em;\"><div>タイトル </div><div><input type=\"text\" name=\"title\" value=\"" . $title . "\" style=\"width:16em;\" /></div></div>\n";
	if (preg_match('/^<strong>(.+)<\/strong>$/',$writer,$match)) {
		$writer = $match[1];
	} else {
		$writer = '';
	}
	$form .= "<div style=\"padding:0.3em;\"><div>投稿者 </div><div><input type=\"text\" name=\"writer\" value=\"" . $writer . "\" style=\"width:10em;\" /></div></div>\n";
	$form .= "<div style=\"padding:0.3em;\"><div>編集パスワード </div><div><input type=\"text\" name=\"password\" style=\"width:10em;\" /></div></div>\n";
	$form .= "<div style=\"padding:0.3em;\">コメント <wbr><textarea name=\"comment\" cols=\"40\" rows=\"3\" style=\"width:90%;\">$comment</textarea></div>\n";
	if ($rewrite && $tenpu_list) {
		$str = '';
		foreach ($tenpu_list as $file) {
			$ext = pathinfo($file,PATHINFO_EXTENSION);
			$hash['id2'] = req('id2');
			$hash['del_file'] = $file;
			$hash['bbs_pass'] = req('bbs_pass');
			$hash['hashed'] = req('hashed');
			$link = script_link($hash);
			$nmb = '';
			if (preg_match('/_(\d+)/', $file, $match)) {
				$nmb = $match[1];
			}
			$str .= "<div style=\"margin:5px;\"><a href=\"$link\">削除</a><br />";
			if (in_array($ext,$img_ext)) {
				$thumb = str_replace(".$ext","thumb.$ext",$file);
				if (file_exists($bbs_dir . '/' . $thumb)) {
					$str .= "<img src=\"{$bbs_dir}/$thumb\" /> ";
				} else {
					$str .= "<img src=\"{$bbs_dir}/$file\"  /> ";
				}
			} else {
				$str .= "$file ";
			}
			if ($nmb) {
				$str .= "<br /><span title=\"この文字列の位置に添付ファイルが表示されます\">[file$nmb]</span>";
			}
			$str .= "</div>\n";
		}
		$form .= "<div style=\"display: flex;flex-wrap:wrap;\">$str</div>\n";
	}
	$form .= "<div style=\"padding:0.3em;\"><div>添付</div><div><input type=\"file\" name=\"upfile\" value=\"\" /><input type=\"text\" name=\"email\" value=\"\" style=\"display:none;\"></div></div>\n";
	$form .= "</div>\n";
	$form .= "<div style=\"padding:0.3em;\"><input id=\"submit\" type=\"submit\" name=\"posted\" value=\"投稿\" />$del_button</div>\n";
	$form .= "</form>\n</div>\n";
	if ($upload_error) { $form .= "<div>" . $upload_error . "</dvi>\n"; }
	if (file_exists($id_path)) {
		if ($hide_form) {
			$link = $script . "?plugin=bbs";
			foreach (array('id','page','sort','item','noform') as $key) {
				if (req($key)) { $link .= "&amp;{$key}=" . req($key); }
			}
			$link .= "&amp;hide_form=0";
			$form = "<div style=\"padding-left:1em;\"><a href=\"$link#bbs\">■フォームを表示する</a></div>\n";
		}
		$form .= "<div style=\"margin:0.5em;\">\n";
		$bbs_keyword = req('bbs_keyword');
		if (req('clear')) { $bbs_keyword = ''; }
		$form .= script_form_file($hash,'bbs');
		$form .= "<div style=\"display:flex;flex-wrap:wrap;justify-content: flex-end;\">";
		$form .= "<div style=\"padding:0.2em;\">キーワード <input type=\"text\" name=\"bbs_keyword\" value=\"$bbs_keyword\" style=\"width:200px;\" /></div>\n";
		$form .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"search\" value=\"検索する\" /></div>\n";
		if ($bbs_keyword) { $form .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"clear\" value=\"クリア\" /></div>"; }
		$form .= "</div>\n";
		$form .= "</form>\n";
		$form .= "</div>\n";
		$hash['bbs_admin'] = 1;
		$admin_link = script_link($hash,'bbs');
		$form .= "<div style=\"text-align:right;font-size:80%;\">$help_link <wbr><a href=\"$admin_link\">管理者用</a></div>\n";
	}
	$form = str_replace("\n","|n|",$form);
	return $form;
}


function user_id() {
	global $bbs_dir;
	$ip = $_SERVER['REMOTE_ADDR'];
	$timestamp = date("Y-m-d");
	if (file_exists($bbs_dir . '/' . 'bbs_seed.cgi')) {
		$secret = file_get_contents($bbs_dir . '/' . 'bbs_seed.cgi');
	} else {
		$secret = random_str(10);
		file_put_contents($bbs_dir . '/' . 'bbs_seed.cgi',$secret,LOCK_EX);
	}
	$id_hash = hash_hmac("sha256", $timestamp.$ip, $secret);
	$id_base64 = base64_encode($id_hash);
	$id = substr($id_base64, 0, 10);
	return $id;
}


function spam_log($sec = '') {
	global $bbs_dir;
	$max_log = 100;
	$max_past = 100;
	$comment = req('comment');
	$comment = str_replace("\r\n","\n",$comment);
	$comment = str_replace("\r","\n",$comment);
	$comment = tag_convert($comment);
	$comment = str_replace("\n","<br />",$comment);
	$remote_addr = $remote_host = $user_agent = '';
	if (isset($_SERVER['REMOTE_ADDR'])) { $remote_addr = $_SERVER['REMOTE_ADDR']; }
	if (isset($_SERVER['REMOTE_HOST'])) { $remote_host = $_SERVER['REMOTE_HOST']; }
	if (isset($_SERVER['HTTP_USER_AGENT'])) { $user_agent = $_SERVER['HTTP_USER_AGENT']; }
	$line = join('<>',array('',time(),req('title'),req('writer'),$comment,req('hashed'),$sec,$remote_addr,$remote_host,$user_agent)) . "\n";
	$spam_path = $bbs_dir . '/bbs_spamlog.cgi';
	file_put_contents($spam_path,$line,FILE_APPEND | LOCK_EX);
	$log = file($spam_path);
	if (isset($log) && count($log) >= $max_log) {
		$past_log = array_splice($log,0,(count($log) - $max_log));
		$file_nmb = 1;
		while (1) {
			$past_path = preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$spam_path);
			if (!file_exists($past_path)) {
				$max_nmb = $file_nmb - 1;
				if ($max_nmb < 1) { $max_nmb = 1; }
				$past_path = preg_replace('/\.cgi$/','_' . $max_nmb . '.cgi',$spam_path);
				break;
			}
			$file_nmb++;
		}
		if (file_exists($past_path) && count(file($past_path)) >= $max_past) {
			$past_path = preg_replace('/\.cgi$/','_' . ($max_nmb + 1) . '.cgi',$spam_path);
		}
		file_put_contents($past_path,$past_log,FILE_APPEND | LOCK_EX);
		file_put_contents($spam_path,$log,LOCK_EX);
	}
}


function user_agent($user_agent) {
	$os = '';
	if (preg_match('/Windows\s*NT\s*([0-9.]+)/',$user_agent,$match)) {
		if ($match[1] == 6.2) {
			$os = 'Windows 8';
		} elseif ($match[1] == 6.1) {
			$os = 'Windows 7';
		} elseif ($match[1] == 10) {
			$os = 'Windows 10';
		}
	}
	return array($os);
}

?>