<?php
// [[calendar();]]
$explan = 'カレンダーを表示し、予定などを保存します。';
$format = '
[[calendar]]	// 引数を省略すると今月のカレンダーを表示
[[calendar(2016,11)]]	// 指定した月を表示するには、年と月を入れる
[[calendar(201802)]]	// こういう表記でもOK
';
// article_dir(article_id())	プラグインで使用するファイルの保存先
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
function calendar ($option = '') {
	global $req,$place,$id, $datadir, $admin_pass_name, $admin_mode;
	$week_color = array('日'=>'crimson','月'=>'','火'=>'','水'=>'','木'=>'','金'=>'','土'=>'blue');
	$holiday_color = '#ff0066';
	$tmp_list = explode('|', $option);
	$option = array();
	$year = $month = '';
	foreach ($tmp_list as $_) {
		if (preg_match('/^\d*$/', $_)) {
			$year = substr($_,0,4);
			$month = substr($_,4,2);
		} elseif (preg_match('/(^\d+),(\d+$)/', $_, $match)) {
			$year = $match[1];
			$month = $match[2];
		} elseif (strpos($_, '=') >= 0) {
			list($key, $val) = explode('=', $_);
			$option[$key] = $val;
		}
	}
	$id = article_id();
	$ope = '';
	if (req('plugin') == 'calendar' && req('id') == $id) {
		$ope = 'ope';
	}
	if ($id == 'all') { $id = ''; }
	$id_dir = article_dir($id);
	$tmpdir = opendir($datadir);
	while ($file = readdir($tmpdir)) {
		if (is_dir($datadir . '/' . $file) || preg_match('/^\.{1,2}$/',$file)) { continue; }
		list($data) = file($datadir . '/' . $file, FILE_IGNORE_NEW_LINES);
		$tmp = explode('<>', $data);
		if (!$admin_mode && isset($tmp[7]) && $tmp[7]) { continue; }
		if (isset($tmp[0])) { $aid = $tmp[0]; }
		if (isset($tmp[1])) { $mtime[$aid] = $tmp[1]; }
		if (isset($tmp[2])) { $title[$aid] = $tmp[2]; }
		if (isset($tmp[3])) { $category[$aid] = $tmp[3]; }
		if (isset($tmp[4])) { $cont[$aid] = $tmp[4]; }
		if (isset($tmp[7])) { $amode[$aid] = $tmp[7]; }
	}
	closedir($tmpdir);
	asort($mtime);
	$article = array();
	foreach ($mtime as $key=>$val) {
		list($ymd) = explode(' ', $val);
		$article[str_replace('/', '-', $ymd)][$key] = $title[$key];
	}
	$id_path = join('/',array($id_dir,'calendar.cgi'));
	$comment = array();
	if (file_exists($id_path)) {
		$log = file($id_path);
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			$comment[$tmp[0]] = $tmp[1];
		}
	}
	if ($ope && req('posted')) {
		if (!is_dir($id_dir)) { mkdir($id_dir); }
		$d = sprintf("%04d-%02d-%02d",req('year'),req('month'),req('day'));
		$com = req('comment');
		if (req('comment') && ! preg_match('/[ぁ-ん]{2}/u', req('comment')) ) {
			error('ひらがなが含まれていません');
		}
		preg_match_all('|https?://[0-9a-z\-\./]+:?[0-9]*|',req('comment'), $url);
		if (count($url[0]) > 2) {
			error('URLを減らしてください');
		}
		$com = str_replace("\r\n","\n",$com);
		$com = str_replace("\r","\n",$com);
		$com = tag_convert($com);
		if (preg_match('/^\s+$/',$com)) { $com = ''; }
		$com = str_replace("\n","<br />",$com);
		$comment[$d] = $com;
		if (!$com) { unset($comment[$d]); }
		ksort($comment);
		$str = "";
		foreach ($comment as $key=>$val) {
			$val = rtrim($val);
			$str .= "$key<>$val\n";
		}
		file_put_contents($id_path,$str,LOCK_EX);
	}
	if ($ope) {
		if (req('year')) { $year = req('year'); }
		if (req('month')) { $month = req('month'); }
	}
	if (empty($year) && empty($month)) {
		$year = date('Y');
		$month = date('n');
	}
	$tmp = array();
	foreach (array_values($mtime) as $mtm) {
		list($date) = explode(' ', $mtm);
		$date = str_replace('/', '-', $date);
		$tmp[] = $date;
	}
	$date_list = array_merge(array_keys($comment), $tmp);
	$month_list = array();
	foreach ($date_list as $date) {
		$tmp = explode('-', $date);
		if (isset($tmp[1])) {
			list($y,$m) = $tmp;
			$month_list[] = join("-", array($y, $m));
		}
	}
	$month_list = array_unique($month_list);
	sort($month_list);
	if ($ope && req('last_exst')) {
		$last_month = '';
		$last = '';
		foreach ($month_list as $month) {
			$tmp = explode('-',$month);
			if (sprintf("%04d%02d",$tmp[0],$tmp[1]) >= sprintf("%04d%02d",req('year'),req('month'))) {
				if ($last_month) {
					list($year,$month) = explode('-',$last_month);
				} else {
					list($year,$month) = array(req('year'),req('month'));
				}
				$last = 1;
				break;
			} else {
				$last_month =$month;
			}
		}
		if (!$last) { list($year,$month) = $tmp; }
	}
	if ($ope && req('next_exst')) {
		$next_month = '';
		$count = 0;
		foreach ($month_list as $month) {
			$tmp = explode('-',$month);
			if (sprintf("%04d%02d",$tmp[0],$tmp[1]) <= sprintf("%04d%02d",req('year'),req('month'))) {
				list($year,$month) = explode('-',$month);
				continue;
			} else {
				list($year,$month) = explode('-',$month);
				$next_month = 1;
				break;
			}
			$count++;
		}
		if (!$next_month) {
			list($year,$month) = array(req('year'),req('month'));
		}
	}
	$form = '';
	if ($ope && req('day')) {
		$day = req('day');
		$date = sprintf("%04d-%02d-%02d",$year,$month,req('day'));
		if (!isset($comment[$date])) { $comment[$date] = ''; }
		$holiday = get_holiday($year,$month,$day);
		if (!$holiday) {
			$holiday = '';
		} else {
			$holiday = "<span style=\"color:$holiday_color;\">($holiday)</span>";
		}
		$hash = array('plugin'=>'calendar','id'=>$id,'year'=>$year,'month'=>$month,'day'=>req('day'),'show_form'=>1);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if ($req['sort']) { $hash['sort'] = $req['sort']; }
		$edit_link = script_link($hash);
		$edit_link = "&nbsp;<a href=\"$edit_link#calendar$id\">編集</a>";
		if (!$comment[$date] || req('show_form')) {
			$edit_link = '';
		}
		$week_name = week_name($year,$month,$day);
		if ($week_name == '日') {
			$week_name = "<span style=\"color:" . $week_color[$week_name] . ";\">$week_name</span>";
		} elseif ($week_name == '土') {
			$week_name = "<span style=\"color:" . $week_color[$week_name] . ";\">$week_name</span>";
		}
		$form .= "<div style=\"margin:0;font-size:90%;\">{$year}年{$month}月{$day}日(" . $week_name . ")" . "$holiday$edit_link</div>\n";
		$form .= "<div>" . $comment[$date] . "</div>\n";
		if (!$comment[$date] || req('show_form')) {
			$form .= "<div>\n";
			$form .= "<div>";
			$hash = array('plugin'=>'calendar','year'=>$year,'month'=>$month,'day'=>$day,'id'=>$id);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if ($req['sort']) { $hash['sort'] = $req['sort']; }
			$form .= script_form($hash,'calendar');
			$com = $comment[$date];
			$com = str_replace("<br />","\n",$com);
			$width = mb_strwidth($com);
			if ($width < 10) {
				$width = 10;
			} elseif ($width > 22) {
				$width = 22;
			}
			$form .= "<input type=\"submit\" name=\"posted\" value=\"投稿\" /></div>\n";
			$form .= "<div><textarea name=\"comment\" style=\"width:{$width}em;\">" . $com . "</textarea></div>\n";
			$form .= "</form>\n</div>\n";
		}
	}
	$last_year = $year;
	$last_month = $month - 1;
	if ($last_month < 1) {
		$last_month += 12;
		$last_year--;
	}
	$next_year = $year;
	$next_month = $month + 1;
	if ($next_month > 12) {
		$next_month -= 12;
		$next_year++;
	}
	$last_year = sprintf("%04d",$last_year);
	$next_year = sprintf("%04d",$next_year);
	$hash = array('plugin'=>'calendar','id'=>$id,'year'=>$year,'month'=>$month);
	$link = script_link($hash);
	$hash['year'] = $last_year;
	$hash['month'] = $last_month;
	$last_link = script_link($hash);
	$hash['year'] = $next_year;
	$hash['month'] = $next_month;
	$next_link = script_link($hash);
	$add = '';
	if (req('noform')) { $add .= "&amp;noform=" . req('noform'); }
	if ($req['sort']) { $add .= "&amp;sort=" . $req['sort']; }
	$link .= $add;
	$tomonth_link = $link;
	$last_link .= $add;
	$next_link .= $add;
	if (!req('day')) {
		$lists = '';
		$keys = array_merge(array_keys($comment), array_keys($article));
		$keys = array_unique($keys);
		sort($keys);
		foreach ($keys as $key) {
			if (preg_match('/^' . sprintf("%04d-%02d",$year,$month) . '/',$key)) {
				list($yy,$mm,$dd) = explode('-',$key);
				$wk = week_name($yy,$mm,$dd);
				if ($wk == '日' || $wk == '土') { $wk = "<span style=\"color:" . $week_color[$wk] . ";\">($wk)</span>"; } else { $wk = "($wk)"; }
				$holiday = get_holiday($yy,$mm,$dd);
				if (! $holiday) { 
					$holiday = '';
				} else {
					$holiday = "<span style=\"color:$holiday_color;\">($holiday)</span>";
				}
				if (isset($comment[$key]) && $comment[$key]) {
					$val = $comment[$key];
					$lists .= "<div style=\"display:flex;flex-wrap:wrap;justify-content:space-between;align-items:center;\">";
					$tmp = explode('<br />',$val);
					$title = str_replace('<br />',"\n",$val);
					$bef = strlen($val);
					$s_str = jtruncate($tmp[0],30);
					$aft = strlen($s_str);
					if ($bef > $aft) { $s_str .= '...'; }
					$lists .= "<div><span title=\"$title\">" . $s_str . "</span></div>";
					$lists .= "<div><span style=\"font-size:80%;\"><a href=\"$link&amp;day=$dd#calendar$id\">" . $key . $wk . $holiday . "</a></span></div>";
					$lists .= "</div>\n";
				}
				if (isset($article[$key]) && $article[$key]) {
					foreach ($article[$key] as $aid=>$val) {
						$class_ = 'list';
						if (isset($amode[$aid]) && $amode[$aid] != '') {
							if (!isset($_COOKIE[$admin_pass_name]) || !$_COOKIE[$admin_pass_name]) {
								continue;
							} else {
								$class_ = 'amode';
							}
						}
						if (req('noform') == $aid) { $class_ = 'current'; }
						if ($class_) { $class_ = " class=\"$class_\""; }
						$art = $val;
						$bef = strlen($art);
						$s_str = jtruncate($art,30);
						$aft = strlen($s_str);
						if ($bef > $aft) { $s_str .= '...'; }
						$hash = array('plugin'=>'calendar', 'id'=>$id, 'noform'=>$aid, 'year'=>$year, 'month'=>$month, 'sort'=>$req['sort'], );
						$link_ = script_link($hash);
						$lists .= "<div$class_ style=\"display:flex;flex-wrap:wrap;justify-content:space-between;align-items:center;\"><div>";
						$lists .= "<a href=\"$link_\" title=\"$art\">" . $s_str . "</a></div><div><span style=\"font-size:80%;\">" . $key . $wk . "</span></div></div>\n";
					}
				}
			}
		}
		$form .= $lists;
	}
	
	//月末の取得
	//$l_day = date('j', mktime(0, 0, 0, $month + 1, 0, $year));
	// 2038年対策済み
	$obj = date_create("$year-$month-01");
	$l_day = date_format($obj,"t");
	//初期出力
	$html = <<<EOM
<table class="calendar">
	<thead>
		<tr>
			<td colspan="2"><a href="$tomonth_link&amp;last_exst=1#calendar$id" title="前の記事がある月へ">|&lt;</a>&nbsp;<a href="$last_link#calendar$id" title="前月へ">&lt;</a></td>
			<th colspan="3"><a href="$tomonth_link#calendar$id" id="calendar$id">{$year}年{$month}月</a></th>
			<td colspan="2"><a href="$next_link#calendar$id" title="翌月へ">&gt;</a>&nbsp;<a href="$tomonth_link&amp;next_exst=1#calendar$id" title="次の記事がある月へ">&gt;|</a></td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<th class="sun">日</th>
			<th>月</th>
			<th>火</th>
			<th>水</th>
			<th>木</th>
			<th>金</th>
			<th class="sat">土</th>
		</tr>\n
EOM;
	$lc = 0;
	$html = str_replace("\t",'',$html);

	// 月末分繰り返す
	for ($i = 1; $i < $l_day + 1;$i++) {
		$classes = array();
		$class   = '';
 
		// 曜日の取得
		//$week = date('w', mktime(0, 0, 0, $month, $i, $year));
		$obj = date_create("$year-$month-$i");
		$week = (int)date_format($obj, 'w');
 
		// 曜日が日曜日の場合
		if ($week == 0) {
			//$html .= "\t\t<tr>\n";
			$html .= "<tr>\n";
			$lc++;
		}
 
		// 1日の場合
		if ($i == 1) {
			if($week != 0) {
				//$html .= "\t\t<tr>\n";
				$html .= "<tr>\n";
				$lc++;
			}
			$html .= repeatEmptyTd2($week);
		}
 		if ($week == 6) {
			$classes[] = 'sat';
		} else if ($week == 0) {
			$classes[] = 'sun';
		}
 		if ($i == date('j') && $year == date('Y') && $month == date('n')) {
			// 現在の日付の場合
			$classes[] = 'today';
		}
		if ($i == req('day') && $year == req('year') && $month == req('month')) {
			$classes[] = 'current';
		}
		$holiday = holiday($year, $month, $i);
		$holiday = mb_convert_encoding($holiday,'utf-8','euc-jp');
 		if (count($classes) > 0) {
			$class = ' class="'.implode(' ', $classes).'"';
		}
		$d = $i;
		$title = '';
		$date = sprintf("%04d-%02d-%02d",$year,$month,$i);
		if ((isset($comment[$date]) && $comment[$date]) || (isset($article[$date]) && $article[$date])) {
			$d = "<b>$i</b>";
			$title = '';
			if (isset($comment[$date]) && $comment[$date]) { $title .= $comment[$date]; }
			if (isset($article[$date]) && $article[$date]) {
				foreach ($article[$date] as $val) {
					$title .= $val;
				}
			}
			$title = str_replace("<br />","\n",$title);
			$title = strip_tags($title);
			$title = " title=\"$title\"";
		}
		if ($id) {
			if ($holiday) {
				if ($title) {
					$title = preg_replace('/title="([\w\W]*?)"/','title="(' . $holiday . ")\n" . '$1"',$title);
				} else {
					$title =" title=\"($holiday)\"";
				}
				if (req('day') == $i) {
					$html .= '<td' . $class . ' style="color:crimson;"><a style="color:crimson;" href="' . $link . "&amp;day=$i#calendar$id" . '"' . $title . '>'.$d.'</a></td>'."\n";
				} else {
					$html .= '<td' . $class . ' style="color:crimson"><a style="color:crimson;" href="' . $link . "&amp;day=$i#calendar$id" . '"' . $title . '>'.$d.'</a></td>'."\n";
				}
			} else {
				if (req('day') == $i) {
					$html .= '<td' . $class . '><a' . ' href="' . $link . "&amp;day=$i#calendar$id" . '"' . $title . '>'.$d.'</a></td>'."\n";
				} else {
					$html .= '<td' . $class . '><a' . $class . ' href="' . $link . "&amp;day=$i#calendar$id" . '"' . $title . '>'.$d.'</a></td>'."\n";
				}
			}
		} else {
			if ($holiday) {
				$html .= '<td style="color:crimson"><a title="' . $holiday . '">'.$d.'</td>'."\n";
			} else {
				$html .= '<td'.$class.'>'.$d.'</td>'."\n";
			}
		}
 
		// 月末の場合
		if ($i == $l_day) {
			$html .= repeatEmptyTd2(6 - $week);
			$week = 6;
		}
		// 土曜日の場合
		if ($week == 6) {
			//$html .= "\t\t</tr>\n";
			$html .= "</tr>\n";
		}
	}
	$html .= "</tbody>\n";
	$html .= "</table>\n";
	if ($form) {
		$html = "<div style=\"display:flex;flex-wrap:wrap;justify-content:space-around;align-items:center;\"><div>$html</div><div style=\"width:100%;\">" . $form . "</div></div>\n";
	} else {
		$html = "<div style=\"display:flex;flex-wrap:wrap;justify-content:space-around;align-items:center;\"><div>$html</div></div>\n";
	}
	$html = str_replace("\n","/n/",$html);
	return $html;
}
 
function repeatEmptyTd2($n = 0) {
	return str_repeat("<td>&nbsp;</td>\n", $n);
}

?>