<?php
$explan = 'commentプラグインに記事の再編集機能を追加
改行も有効にした
<h3>指定できるオプション</h3>
<dl><dt>order</dt><dd>フォームの表示位置
例　order=up (フォームを上に配置)　order=down (フォームを下に配置)</dd>
<dt>max_log</dt><dd>ログの保存数。これを超えると削除。
例　max_log=50</dd>
<dt>show_days</dt><dd>投稿の表示日数。この日数を超えると表示しない。
例　show_days=50</dd></dl>';
$format = "[[comment2]]	// 基本形
[[comment2('order=up|max_log=10|show_days=90')]]	// フォームを上に配置
";

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function comment2($order = '',$max_log = '') {
	global $current_time,$new_day, $crypt_pass, $id, $id_dir, $id_path, $log, $req;
	if (! $max_log) { $max_log = 20; }	// ログの保存数
	if (gettype($order) == 'integer') {
		$max_log = $order;
		$order = '';
	}
	if (strpos($order,'=') != false) {
		$tmp = explode('|',$order);
		$option = array();
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			if (isset($tmp2[1])) { $option[$tmp2[0]] = $tmp2[1]; }
		}
		$order = '';
	}
	if (!isset($option['show_days'])) { $option['show_days'] = 0; }
	if (isset($option['max_log'])) { $max_log = $option['max_log']; } else { $max_log = 20; }
	if (isset($option['order'])) { $order = $option['order']; } 
	$str = '';
	$id = article_id();
	if (!$id) { $id = req('id'); }
	if (!$id) { $id = req('noform'); }
	if (!$id) { $id = req('edit'); }
	if ($id == 'all') { $id = ''; }
	if (file_exists('./frontid')) {
		list($id) = file('./frontid');
	}
	$id_dir = article_dir($id);
	$id_path = join('/',array($id_dir,'comment2.cgi'));
	$log = array();
	$last = '';
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path, FILE_IGNORE_NEW_LINES);
		$last = end($log);
		$last = rtrim($last);
	}
	if (req('comment2_admin')) { return comment2_admin(); }

	if ((req('posted') || req('comment2_delete')) && req('plugin') == 'comment2') {
		if (!$id) {
			error('このフォームからは投稿できません');	// IDが特定されないフォームからの投稿は拒否
		} else {
			if (!is_dir($id_dir)) { mkdir($id_dir); }
			$obj = date_create('');
			$tm = date_format($obj, 'Y-m-d H:i:s');
			if (! req('comment2_delete')) {
				if (req('comment') && ! preg_match('/[ぁ-ん]{2}/u', req('comment')) ) {
					error('ひらがなが含まれていません');
				}
				preg_match_all('|https?://[0-9a-z\-\./]+:?[0-9]*|',req('comment'), $url);
				if (count($url[0]) > 2) {
					error('URLを減らしてください');
				}
			}
			$comment = req('comment');
			// 改行を削除
			$comment = str_replace("\r\n","\n",$comment);
			$comment = str_replace("\r","\n",$comment);
			$comment = tag_convert($comment);
			$comment = str_replace("\n","<br />",$comment);
			$writer = req('writer');
			$tmp = explode('<>',$last);
			for ($i=0;$i<=2;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			if ($comment == $tmp[2] && $tm == $tmp[0]) {
				//$str .= "コメントが同じなので、キャンセル<br>";
			} else {
				if (preg_match('/^\s?$/',$comment)) {
					error('コメント内容がありません');
				}
				if (!$writer) { $writer = '名無し'; }
				
				// 再編集の場合
				if (req('rewrite') && req('hashed')) {
					$new_log = array();
					foreach ($log as $line) {
						$line = rtrim($line);
						if (strpos($line,'<>') == false) { continue; }
						$tmp = explode('<>',$line);
						if ($tmp[3] == req('hashed')) {
							if (req('comment2_delete')) {
								continue;
							} else {
								$hashed = $tmp[3];
								// パスワード欄が入力されていたらハッシュを再生成
								if (req('password')) {
									$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
								}
								$line = join('<>',array($tm,$writer,$comment,$hashed));
							}
						}
						$new_log[] = $line . "\n";
					}
					file_put_contents($id_path,$new_log,LOCK_EX);
				
				// 新規登録の場合
				} else {
					if (req('password')) {
						$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
					} else {
						$hashed = '';
					}
					$line = join('<>',array($tm,$writer,$comment,$hashed)) . "\n";
					file_put_contents($id_path,$line,FILE_APPEND | LOCK_EX);
				}
			}
		}
	}
	
	$log = array();
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		if (count($log) > $max_log) {
			$log = array_slice($log,-1*$max_log);
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	
	if ($log) {
		$str .= "<ul style=\"list-style-type: square;\">\n";
		if ($order == 'up') {
			$log = array_reverse($log);
		}
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			$datetime1 = date_create($tmp[0]);
			$datetime2 = date_create($current_time);
			if (gettype($datetime1) == 'object' && gettype($datetime2) == 'object') {
				$interval = date_diff($datetime1, $datetime2);
				$dif_days = $interval->format('%R%a');
				$dif_days = intval($dif_days);
				if ($option['show_days'] && ($dif_days > $option['show_days'])) {
					continue;
				}
			}
			$tmp[3] = rtrim($tmp[3]);
			for ($i=0;$i<=3;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			$hash = array('plugin'=>'comment2','id'=>$id,'hashed'=>$tmp[3]);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			}
			if ($req['sort']) {
				$hash['sort'] = $req['sort'];
			}
			$edit_link = script_link($hash);
			$tmp[3] = rtrim($tmp[3]);
			if (req('hashed') && req('hashed') == $tmp[3] && !req('comment2_pass') && !req('posted')) {
				$str .= "<li id=\"comment2\" style=\"margin:0.5em;\">" . $tmp[2] . "&nbsp;-&nbsp;" . $tmp[1] . "&nbsp;-&nbsp;<span style=\"font-size:80%;\">" . $tmp[0] . "</span>";
			} else {
				$str .= "<li style=\"margin:0.5em;\">" . $tmp[2] . "&nbsp;-&nbsp;" . $tmp[1] . "&nbsp;-&nbsp;<span style=\"font-size:80%;\">" . $tmp[0] . "</span>";
			}
			if (req('hashed') && req('hashed') == $tmp[3] && !req('comment2_pass') && !req('posted')) {
				$hash = array('plugin'=>'comment2','id'=>$id,'hashed'=>req('hashed'));
				if (req('noform')) {
					$hash['noform'] = req('noform');
				}
				if ($req['sort']) {
					$hash['sort'] = $req['sort'];
				}
				$str .= script_form($hash,'comment2');
				$str .= "&nbsp;&nbsp;<span style=\"font-size:80%;color:#0066dd;\">編集パスワードを入力してください</span>&nbsp;<input type=\"text\" name=\"comment2_pass\" value=\"\" style=\"width:140px;\" /><input id=\"comment2\" type=\"submit\" value=\"編集\" />";
				$str .= "</form>\n";
			} elseif (req('hashed') && req('hashed') == $tmp[3] && req('comment2_pass') && ! password_verify(req('comment2_pass'),req('hashed')) && ! password_verify(req('comment2_pass'),$crypt_pass)) {
				if ($tmp[3]) { $str .= "&nbsp;<a href=\"$edit_link#comment2\" style=\"white-space:nowrap;\">編集</a>" . "&nbsp;<span style=\"color:crimson\">パスワードが違います</span>"; }
			} else {
				if ($tmp[3]) { $str .= "&nbsp;<a href=\"$edit_link#comment2\" style=\"white-space:nowrap;\">編集</a>"; }
			}
			$str .= "</li>\n";
			$comment_[$tmp[3]] = $tmp[2];
			$writer_[$tmp[3]] = $tmp[1];
			$date_[$tmp[3]] = $tmp[0];
		}
		$str .= "</ul>\n";
	}
	$writer = '';
	$comment = '';
	$hash = array('plugin'=>'comment2','id'=>$id,'plugin'=>'comment2',);
	$form = script_form($hash,'comment2');
	$rewrite = 0;
	if (req('hashed') && req('comment2_pass')) {
		if (password_verify(req('comment2_pass'),req('hashed')) || password_verify(req('comment2_pass'),$crypt_pass)) {
			$comment = $comment_[req('hashed')];
			$writer = $writer_[req('hashed')];
			$form .= "<input type=\"hidden\" name=\"rewrite\" value=\"1\" />\n";
			$form .= "<input type=\"hidden\" name=\"hashed\" value=\"" . req('hashed') . "\" />\n";
			$rewrite = 1;
		}
	}
	if (req('noform')) { $form .= "<input type=\"hidden\" name=\"noform\" value=\"" . req('noform') . "\" />\n"; }
	if ($req['sort']) { $form .= "<input type=\"hidden\" name=\"sort\" value=\"" . $req['sort'] . "\" />\n"; }
	$comment = str_replace("<br />","|n|",$comment);
	if ($rewrite) {
		$input_del = "&nbsp;&nbsp;&nbsp;<input type=\"submit\" name=\"comment2_delete\" value=\"削除\">";
	} else {
		$input_del = '';
	}
	$form .= "<div style=\"margin:0.3em;\"><input id=\"comment2\" type=\"submit\" name=\"posted\" value=\"投稿\" />$input_del</div>\n";
	$form .= "<div style=\"display: flex;flex-wrap:wrap;\">\n";
	$form .= "<div style=\"margin:0.3em;\"><div>投稿者</div><div><input type=\"text\" name=\"writer\" value=\"" . $writer . "\" style=\"width:140px;\" /></div></div>\n";
	$form .= "<div style=\"margin:0.3em;\"><div>編集パスワード</div><div><input type=\"text\" name=\"password\" style=\"width:140px;\" /></div></div>\n";
	$hash = array('plugin'=>'comment2', 'id'=>$id, 'noform'=>req('noform'), 'sort'=>$req['sort'], 'comment2_admin'=>1);
	$form .= "<div style=\"margin:0.3em;margin-left:auto;\"><a href=\"" . script_link($hash) . "#comment2pass$id\" style=\"font-size:80%;\">管理者用</a></div></div>\n";
	$form .= "<div style=\"margin:0.3em;\"><div>コメント</div><div><textarea name=\"comment\" cols=\"40\" rows=\"3\">$comment</textarea></div></div>\n";
	$form .= "</form>";
	$form = "<div style=\"margin:1em;\">$form</div>\n";
	if (!$order || $order == 'down') {
		return $str . $form;
	} elseif ($order == 'up') {
		return $form . $str;
	}
}


function comment2_admin() {
	global $id, $id_dir,$str,$log,$id_path,$id,$img_ext, $req;
	$login_time = 30;
	$mes = '';
	$tmpdir = opendir($id_dir);
	while ($file = readdir($tmpdir)) {
		if (preg_match('/^comment2_admin_.+\.cgi$/',$file)) {
			if (fileatime($id_dir . '/' . $file) < time() - $login_time*60) {
				unlink($id_dir . '/' . $file);
			}
		}
	}
	closedir($tmpdir);
	$hash = array();
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^comment2_admin/',$key)) { continue; }
		if (preg_match('/^(comment2_|mod_|del_|pass)/',$key)) { continue; }
		$hash[$key] = req($key);
	}
	$str .= "<a href=\"" . script_link($hash,'bbs') . "\">戻る</a>";
	$hash['comment2_admin'] = 1;
	if (req('comment2_admin_login')) {
		$hash['comment2_admin_login'] = req('comment2_admin_login');
		$str .= "&nbsp;&nbsp;<a href=\"" . script_link($hash,'comment2') . "\">再読み込み</a>";
	}
	if (!req('comment2_admin_login')) {
		if (! req('pass')) {
			$hash = array();
			foreach (array_keys($_REQUEST) as $key) { $hash[$key] = req($key); }
			$str .= script_form($hash,'comment2');
			if (isset($_COOKIE['comment2_admin_pass'])) {
				$cpass = $_COOKIE['comment2_admin_pass'];
			} else {
				$cpass = '';
			}
			$str .= "<input id=\"comment2pass$id\" type=\"password\" name=\"pass\" value=\"$cpass\" size=\"12\">";
			$str .= " <input type=\"submit\" name=\"login\" value=\"ログイン\">";
			$str .= "</form>\n";
			return $str;
		} else {
			global $crypt_pass, $cookietime;
			if (decrypt(req('pass'), $crypt_pass) === 'no') {
				error("パスワードが認証できません");
			} else {
				$login_id = random_str(10);
				$comment2_admin_login = $hash['comment2_admin_login'] = $login_id;
				file_put_contents(join('/',array($id_dir, 'comment2_admin_' . $login_id . '_' . $_SERVER['SERVER_NAME'] . '.cgi')),'',LOCK_EX);
				// クッキーの場合、エポック時間はどうなるのか？
				setcookie("comment2_admin_pass", req('pass'), time() + $cookietime * 3600 * 24);
				setcookie("comment2_cpass", req('pass'), time() + 3600*24);		// アクセス権限を管理者レベルにするためのクッキー
			}
			$hash['pass'] = '';
		}
	} else {
		$login_path = join('/',array($id_dir, 'comment2_admin_' . req('comment2_admin_login') . '_' . $_SERVER['SERVER_NAME'] . '.cgi'));
		$lhash = array('plugin'=>'comment2', 'id'=>req('id'),'noform'=>req('noform'),'sort'=>$req['sort'],'comment2_admin'=>1);
		$relogin = script_link($lhash,'comment2');
		if (! file_exists($login_path) ) {
			error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
		} else {
			if (filemtime($login_path) + 60 * $login_time < time()) {
				unlink($login_path);
				error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin\">ログイン</a>");
			} else {
				file_put_contents($login_path,'',LOCK_EX);
			}
		}
	}
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^del_(\w+$)/',$key,$match)) {
			$del_id = $match[1];
			$new_log = array();
			$tmp_log = array_reverse($log);
			$mes .= '<div><strong>[' . str_replace('<>', '  ', $tmp_log[$del_id - 1]) . ']</strong> の記事を削除しました。</div>';
			unset($tmp_log[$del_id - 1]);
			$log = array_reverse($tmp_log);
			file_put_contents($id_path, join("\n", $log), LOCK_EX);
			break;
		}
	}
	if (!isset($comment2_admin_login) || !$comment2_admin_login) { $comment2_admin_login = req('comment2_admin_login'); }
	$hash = array('plugin'=>'comment2', 'id'=>$id, 'comment2_admin'=>1, 'comment2_admin_login'=>$comment2_admin_login);
	if (req('noform')) { $hash['noform'] = req('noform'); }
	$indx = '';
	$str .= "<div style=\"color:crimson\">$mes</div>\n";
	$hash['show_spam'] = 0;
	$hash['comment2_admin'] = 1;
	$hash['edit_ng'] = 0;
	if (req('comment2_admin_login')) { $hash['comment2_admin_login'] = req('comment2_admin_login'); }
	$str .= script_form($hash);
	$str .= "<div>\n";
	$hash['comment2_admin'] = 1;
	$count = 0;
	foreach (array_reverse($log) as $line) {
		$count++;
		list($date, $name, $comment) = explode('<>', $line);
		if ($count % 2) {
			$backcol = "background-color:#dddddd;";
		} else {
			$backcol = "";
		}
		$str .= "<div style=\"display:flex;flex-wrap:wrap;align-items:flex-start;padding:0.2em;$backcol\">";
		$str .= "<div style=\"padding:0.2em;\"><span style=\"font-size:80%;\">$date</span></div>";
		$str .= "<div style=\"padding:0.2em;flex-basis:7em;\">$name</div>";
		$str .= "<div style=\"padding:0.2em;\">$comment</div>";
		$hash['del_' . $count] = 1;
		$str .= "<div style=\"padding:0.2em;margin-left:auto;\"><input type=\"submit\" name=\"del_" . $count . "\" value=\"削除\" style=\"font-size:80%;\"></div>";
		$str .= "</div>\n";
	}
	$str .= "</div>\n";
	$str .= "</form>\n";
	$str = str_replace("\n","|n|",$str);
	return $str;
}

?>