<?php
global $comment3_help;
$explan = 'comment2プラグインにファイル添付機能を追加';
$format = "[[comment3]]	// 基本形
[[comment3('hide=1')]]	// デフォルトでフォームや投稿内容を表示しない
";
$comment3_help = "
<h3>指定できるオプション</h3>
<dl><dt>tag</dt><dd>使用できるタグを指定
tag=pre,span　複数指定する場合は,(カンマ)で区切る</dd></dl>
<dl><dt>max_log</dt><dd>現行ログの保存数。これを超えると過去ログに移動。
例　max_log=50</dd></dl>
<dl><dt>max_past</dt><dd>過去ログに保存する記事数。これを超えると過去ログファイルを新たに作成。
例　max_past=50</dd></dl>
<dl><dt>order</dt><dd>フォームの表示位置。
例　order=up</dd></dl>
<dl><dt>page_line</dt><dd>1ページに表示する記事数。これを超えると次のページに表示
例　page_line=10</dd></dl>
<dl><dt>hide</dt><dd>デフォルトでフォームや投稿内容を表示しない
例　hide=1</dd></dl>
";
$explan .= $comment3_help;
////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function comment3($order = '',$max_log = '') {
	global $img_ext,$comment3_help,$tag_list, $id, $id_dir, $log, $id_path, $crypt_pass;
	if (! $max_log) { $max_log = 100; }	// ログの保存数
	$max_past = 100;					// 過去ログの最大数
	if (gettype($order) == 'integer') {
		$max_log = $order;
		$order = '';
	}
	if (strpos($order,'=') != false) {
		$tmp = explode('|',$order);
		$option = array();
		$order = '';
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			if (isset($tmp2[1])) {
				$option[$tmp2[0]] = $tmp2[1];
				if ($tmp2[0] == 'order') {
					$order = $tmp2[1];
				}
			}
		}
	}
	if (!isset($option['order'])) { $option['order'] = 'up'; }	// フォームの表示位置
	if (!isset($option['max_log'])) { $option['max_log'] = 100; }	// ログの保存数
	if (!isset($option['max_past'])) { $option['max_past'] = 100; }	// 過去ログの保存数
	if (!isset($option['tag'])) { $option['tag'] = ''; }	// 許可するタグ
	if (!isset($option['page_line'])) { $option['page_line'] = 10; }	// 1ページに表示する記事数
	if (!isset($option['hide'])) { $option['hide'] = 0; }	// 1ページに表示する記事数
	$page_line = $option['page_line'];
	$str = '';
	$id = article_id();
	if (!$id) { $id = req('id'); }
	if (!$id) { $id = req('noform'); }
	if (!$id) { $id = req('edit'); }
	if ($id == 'all') { $id = ''; }
	if (file_exists('./frontid')) {
		list($id) = file('./frontid');
	}
	$id_dir = article_dir($id);
	$id_path = join('/',array($id_dir,'comment3.cgi'));
	$log = array();
	$last = '';
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		$last = end($log);
		$last = rtrim($last);
	}

	$hash = array('plugin'=>'comment3','id'=>$id,'comment3_help'=>0, 'hide'=>1);
	if (req('noform')) { $hash['noform'] = req('noform'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }
	$hide_link = "<a href=\"" . script_link($hash,'comment3_top') . "\">コメントを隠す</a>";
	if (req('comment3_admin')) {
		return(comment3_admin());
	}
	if (req('comment3_help')) {
		$hash = array('plugin'=>'comment3','id'=>$id,'comment3_help'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		$str .= "<a href=\"" . script_link($hash) . "#comment3_top\">戻る</a>";
		$str .= "<h2 id=\"comment3_help\">comment3.phpのヘルプ</h2>";
		$comment3_help = preg_replace('/>\n+/',">\n",$comment3_help);
		$tmp = explode("\n",$comment3_help);
		foreach ($tmp as $_) {
			$mat = $trans = '';
			if (preg_match('/<dt>([^<]+)<\/dt>/',$_,$mat)) {
				if (isset($mat[1]) && isset($option[$mat[1]])) {
					$trans = " (現在の設定は" . $mat[1] . '=' . $option[$mat[1]] . ')';
				}
				$_ = preg_replace('/<dt>([^<]+)<\/dt>/',"<b>" . $mat[1] . "</b>" . $trans,$_);
			}
			if (!preg_match('/>$/',$_)) {
				$str .= $_ . "<br />\n";
			} else {
				$str .= $_ . "\n";
			}
		}
		$str = str_replace("\n","|n|",$str);
		$str = str_replace("!perm_tag!",$option['tag'],$str);
		return "<div id=\"comment3_top\">$str</div>\n";
	}
	if (req('hide') || ($option['hide'] && req('plugin') != 'comment3')) {
		$hash = array('plugin'=>'comment3','id'=>$id,'comment3_help'=>0, 'show'=>1);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		if (req('item')) { $hash['item'] = req('item'); }
		if (count($log)) {
			$comstr = count($log) . '件のコメント';
		} else {
			$comstr = 'コメントを投稿する';
		}
		$str .= "<a href=\"" . script_link($hash,'comment3') . "#comment3_top\">$comstr</a>";
		return "<div id=\"comment3_top\">$str</div>\n";
	}

	if (req('show_past')) {
		$file_nmb = 1;
		while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
			$file_nmb++;
		}
		if (req('past_nmb')) {
			$past_nmb = req('past_nmb');
		} else {
			$past_nmb = $file_nmb - 1;
		}
		$hash = array('plugin'=>'comment3','id'=>$id,'show_past'=>0);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }

		$str .= "<a href=\"" . script_link($hash) . "#comment3_top\">戻る</a>&nbsp;<strong>過去ログ</strong> ";
		$nmb = 1;
		$show_next_id = 0;
		for ($i=$file_nmb-1; $i>=1; $i--) {
			if ($i == $past_nmb) {
				$str .= "<b>[$nmb]</b> \n";
			} else {
				$hash = array('plugin'=>'comment3','id'=>$id,'past_nmb'=>$i,'show_past'=>1);
				if (req('noform')) { $hash['noform'] = req('noform'); }
				if (req('sort')) { $hash['sort'] = req('sort'); }
				$link = script_link($hash) . "#next_page";
				if (!$show_next_id) {
					$str .= "<a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . $nmb . "]</a> \n";
					$show_next_id = 1;
				} else {
					$str .= "<a href=\"$link\">[" . $nmb . "]</a> \n";
				}
			}
			$nmb++;
		}
		$str .= '  ' . $hide_link;
		$past_path = preg_replace('/\.cgi$/','_' . $past_nmb . '.cgi',$id_path);
		$log = file($past_path);
		$log = array_reverse($log);
		$com = '';
		foreach ($log as $line) {
			$tmp = explode('<>',$line);
			list($id,$date,$name,$comment,$hashed) = $tmp;
			if (isset($tmp[5])) { $rewrite = $tmp[5]; }
			$com .= "<li>$date&nbsp;$name<br />";
			$tmpdir = opendir($id_dir);
			while ($file = readdir($tmpdir)) {
				if (strpos($file,$id) !== false && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$ext = pathinfo($file,PATHINFO_EXTENSION);
					if (in_array($ext,$img_ext)) {
						list($image_w, $image_h) = getimagesize($id_dir . "/$file");
						$width = 500;
						$proportion = $image_w / $image_h;
						$height = $width / $proportion;
						//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
						if($proportion < 1){
							$height = $width;
							$width = $width * $proportion;
							$width = intval($width * 0.8);
							$height = intval($height * 0.8);
						}
						$com .= "<a href=\"" . $id_dir . "/$file\"><img src=\"" . $id_dir . "/$file\" width=\"$width\" alt=\"$file\" /></a><br />\n";
					} else {
						$oname = $id_dir . '/' . $file . '.oname';
						$org = $file;
						if (file_exists($oname)) { list($org) = file($oname); }
						$hash = array('mode'=>'download', 'file'=>$id_dir . '/' . $file, 'name'=>urlencode($org));
						$link = script_link($hash) . "#comment3_top";
						$com .= "<a href=\"$link\">$org</a><br />\n";
					}
				}
			}
			closedir($tmpdir);
			$com .= "$comment\n<hr /></li>\n";
		}
		if ($com) { $com = "<ul>$com</ul>\n"; }
		$str .= $com;
		$str = str_replace("\n","|n|",$str);
		return "<div id=\"comment3_top\">$str</div>\n";
	}
	if ((req('posted') || req('comment3_delete')) && req('plugin') == 'comment3') {
		if (!$id) {
			error('このフォームからは投稿できません');	// IDが特定されないフォームからの投稿は拒否
		} else {
			if (!is_dir($id_dir)) { mkdir($id_dir); }
			$tag_list = explode(',',$option['tag']);
			$obj = date_create('');
			$tm = date_format($obj, 'Y-m-d H:i:s');
			if (! req('comment3_delete')) {
				if (req('comment') && ! preg_match('/[ぁ-ん]{2}/u', req('comment')) ) {
					error('ひらがなが含まれていません');
				}
				preg_match_all('|https?://[0-9a-z\-\./]+:?[0-9]*|',req('comment'), $url);
				if (count($url[0]) > 2) {
					error('URLを減らしてください');
				}
			}
			$comment = req('comment');
			// 改行を削除
			$comment = str_replace("\r\n","\n",$comment);
			$comment = str_replace("\r","\n",$comment);
			$comment = tag_convert($comment);
			$comment = str_replace("\n","<br />",$comment);
			$writer = req('writer');
			$tmp = explode('<>',$last);
			$id2 = $tmp[0];
			for ($i=0;$i<=3;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			if ($comment == $tmp[3] && $tm == $tmp[1]) {
				//$str .= "コメントが同じなので、キャンセル<br>";
			} else {
				if (preg_match('/^\s?$/',$comment)) {
					error('コメント内容がありません');
				}
				if (!$writer) { $writer = '匿名'; }
				
				// 再編集の場合
				if (req('rewrite') && req('hashed')) {
					$new_log = array();
					foreach ($log as $line) {
						$line = rtrim($line);
						if (strpos($line,'<>') == false) { continue; }
						$tmp = explode('<>',$line);
						if ($tmp[0] == req('id2') && $tmp[4] == req('hashed')) {
							$id2 = $tmp[0];
							if (req('comment3_delete')) {
								$tmpdir = opendir($id_dir);
								while ($file = readdir($tmpdir)) {
									if (preg_match('/^' . $id2 . '/',$file)) {
										unlink($id_dir . '/' . $file);
									}
								}
								closedir($tmpdir);
								continue;
							} else {
								$hashed = $tmp[4];
								// パスワード欄が入力されていたらハッシュを再生成
								if (req('password')) {
									$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
								}
								$line = join('<>',array($id2,$tm,$writer,$comment,$hashed,'再編集'));
							}
						}
						$new_log[] = $line . "\n";
					}
					file_put_contents($id_path,$new_log,LOCK_EX);
				
				// 新規登録の場合
				} else {
					if (req('password')) {
						$hashed = password_hash(req('password'),PASSWORD_DEFAULT);
					} else {
						$hashed = '';
					}
					$id2 = random_str(10);
					$line = join('<>',array($id2,$tm,$writer,$comment,$hashed)) . "\n";
					file_put_contents($id_path,$line,FILE_APPEND | LOCK_EX);
				}
			}

			// すでにアップロードしたファイルがある場合は削除しておく
			$tmpdir = opendir($id_dir);
			while ($file = readdir($tmpdir)) {
				// 同じ記事に複数のcomment3が設置されている場合の対策 100秒以上経過しているファイルのみ削除
				if (strpos($file,$id2) !== false && filemtime($id_dir . '/' . $file) + 100 < time()) {
					unlink($id_dir . '/' . $file);
				}
			}
			closedir($tmpdir);
			
			if (isset($_FILES['upfile']["error"]) && $_FILES['upfile']["error"] == UPLOAD_ERR_OK) {
				$tmp_name = $_FILES['upfile']["tmp_name"];
				$t_name = $_FILES['upfile']["name"];	// とりあえず元のファイル名から拡張子を取るだけ
				$ext = pathinfo($t_name, PATHINFO_EXTENSION);
				if (! is_dir($id_dir)) {
					mkdir($id_dir);
				}
				$up_path = $id_dir . '/' . $id2 . '.' . $ext;
				file_upload('upfile', $up_path);
			}
		}
	}
	$log = array();
	if (is_dir($id_dir) && file_exists($id_path)) {
		$log = file($id_path);
		if (count($log) > $option['max_log']) {
			$past_log = array_splice($log,0,(count($log) - $option['max_log']));
			$file_nmb = 1;
			while (1) {
				$past_path = preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path);
				if (!file_exists($past_path) || count(file($past_path)) < $option['max_past']) {
					file_put_contents($past_path,$past_log,FILE_APPEND | LOCK_EX);
					break;
				}
				$file_nmb++;
			}
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	if ($log) {
		$log = array_reverse($log);	// 新しい順に表示するのに固定
		//$page_line = 10;	// 1ページあたりの記事数
		$line_nmb = 0;
		if (! req('comment3_page')) {
			$comment3_page = 0;
		} else {
			$comment3_page = req('comment3_page');
		}
		$end = intval((count($log) - 1)/$page_line);
		$indx = '';
		if ($end > 0) {
			$show_next_id = 0;
			for ($i=0; $i<=$end; $i++) {
				if ($i == $comment3_page) {
					$indx .= "<b>[" . ($i+1) . "]</b> \n";
				} else {
					$hash = array('plugin'=>'comment3','id'=>$id,'comment3_page'=>$i);
					if (req('noform')) { $hash['noform'] = req('noform'); }
					if (req('sort')) { $hash['sort'] = req('sort'); }
					$link = script_link($hash) . "#next_page";
					if (!$show_next_id) {
						$indx .= "<a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . ($i+1) . "]</a> \n";
						$show_next_id = 1;
					} else {
						$indx .= "<a href=\"$link\">[" . ($i+1) . "]</a> \n";
					}
				}
			}
		}
		$past_path = preg_replace('/\.cgi$/','_1.cgi',$id_path);
		if (file_exists($past_path)) {
			$hash = array('plugin'=>'comment3','id'=>$id,'show_past'=>1);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if (req('sort')) { $hash['sort'] = req('sort'); }
			$indx .= "<a href=\"" . script_link($hash) . "#comment3_top\">過去ログ</a>";
		}
		$indx .= ' ' . $hide_link;
		if ($indx) { $indx = "<div style=\"margin-left:1em;\">$indx</div>\n"; }
		$str .= $indx . "<ul style=\"list-style-type: square;\">\n";
		foreach ($log as $line) {
			if ($line_nmb < $comment3_page * $page_line || $line_nmb >= ($comment3_page + 1) * $page_line) {
				$line_nmb++;
				continue;
			}
			$tmp = explode('<>',$line);
			$id2 = $tmp[0];
			$tmp[4] = rtrim($tmp[4]);
			for ($i=0;$i<=4;$i++) {
				if (!isset($tmp[$i])) { $tmp[$i] = ''; }
			}
			$hash = array('plugin'=>'comment3','id'=>$id,'hashed'=>$tmp[4],'id2'=>$id2);
			if (req('noform')) {
				$hash['noform'] = req('noform');
			}
			if (req('sort')) {
				$hash['sort'] = req('sort');
			}
			if (req('comment3_page')) {
				$hash['comment3_page'] = req('comment3_page');
			}
			$edit_link = script_link($hash);
			$tmp[4] = rtrim($tmp[4]);
			if (req('hashed') && req('hashed') == $tmp[4] && !req('comment3_pass') && !req('posted')) {
				$str .= "<li id=\"comment3\" style=\"margin:0.5em;\">" . "<span style=\"font-size:80%;\">" . $tmp[1] . "</span>" . $tmp[2];
			} else {
				$str .= "<li style=\"margin:0.5em;\">" . "<span style=\"font-size:80%;\">" . $tmp[1] . "</span>" . $tmp[2];
			}
			if ($tmp[4]) {
				$str .= "&nbsp;&nbsp;<a href=\"$edit_link#comment3\" style=\"white-space:nowrap;\">編集</a>\n";
			}
			$str .= "<br />\n";
			$tmpdir = opendir($id_dir);
			while ($file = readdir($tmpdir)) {
				if (preg_match('/^' . $id2 . '/',$file) && strpos($file,'oname') === false && strpos($file,'thumb') === false && strpos($file,'count') === false) {
					$ext = pathinfo($file,PATHINFO_EXTENSION);
					if (in_array($ext,$img_ext)) {
						list($image_w, $image_h) = getimagesize($id_dir . "/$file");
						$width = 500;
						$proportion = $image_w / $image_h;
						$height = $width / $proportion;
						//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
						if($proportion < 1){
							$height = $width;
							$width = $width * $proportion;
							$width = intval($width * 0.8);
							$height = intval($height * 0.8);
						}
						$str .= "<a href=\"" . $id_dir . "/$file\"><img src=\"" . $id_dir . "/$file\" width=\"$width\" alt=\"$file\" /></a><br />\n";
					} else {
						$oname = $id_dir . '/' . $file . '.oname';
						$org = $file;
						if (file_exists($oname)) {
							list($org) = file($oname);
						}
						$hash = array('mode'=>'download', 'file'=>$id_dir . '/' . $file, 'name'=>urlencode($org));
						$link = script_link($hash);
						$str .= "<a href=\"$link\">$org</a><br />\n";
					}
				}
			}
			closedir($tmpdir);
			if (req('hashed') && req('hashed') == $tmp[4] && !req('comment3_pass') && !req('posted')) {
				$str .= $tmp[3];
			} else {
				$str .= $tmp[3];
			}
			if (req('hashed') && req('hashed') == $tmp[4] && !req('comment3_pass') && !req('posted')) {
				$hash = array('plugin'=>'comment3','id'=>$id,'hashed'=>req('hashed'),'id2'=>$id2);
				if (req('noform')) {
					$hash['noform'] = req('noform');
				}
				if (req('sort')) {
					$hash['sort'] = req('sort');
				}
				if (req('comment3_page')) {
					$hash['comment3_page'] = req('comment3_page');
				}
				$str .= script_form_file($hash,'comment3');
				$str .= "&nbsp;&nbsp;<span style=\"font-size:80%;color:#0066dd;\">編集パスワードを入力してください</span>&nbsp;<input type=\"text\" name=\"comment3_pass\" value=\"\" style=\"width:140px;\" /><input id=\"comment3\" type=\"submit\" value=\"編集\" />";
				$str .= "</form>\n";
			} elseif (req('hashed') && req('hashed') == $tmp[4] && req('comment3_pass') && ! password_verify(req('comment3_pass'),req('hashed')) && ! password_verify(req('comment3_pass'),$crypt_pass)) {
				if ($tmp[4]) { $str .= "&nbsp;<span style=\"color:crimson\">パスワードが違います</span>"; }
			}
			$str .= "<hr />\n</li>\n";
			$comment_[$tmp[4]] = $tmp[3];
			$writer_[$tmp[4]] = $tmp[2];
			$date_[$tmp[4]] = $tmp[1];
			$line_nmb++;
		}
		$str .= "</ul>\n";
	}
	$writer = '';
	$comment = '';
	$hash = array('plugin'=>'comment3','id'=>$id);
	if (req('id2')) { $hash['id2'] = req('id2'); }
	if (req('comment3_page')) { $hash['comment3_page'] = req('comment3_page'); }
	$form = "<div id=\"comment3\" style=\"margin:1em;\">" . script_form_file($hash,'comment3_top');
	$rewrite = 0;
	if (req('hashed') && req('comment3_pass')) {
		if (password_verify(req('comment3_pass'),req('hashed')) || password_verify(req('comment3_pass'),$crypt_pass)) {
			$comment = $comment_[req('hashed')];
			$writer = $writer_[req('hashed')];
			$form .= "<input type=\"hidden\" name=\"rewrite\" value=\"1\" />\n";
			$form .= "<input type=\"hidden\" name=\"hashed\" value=\"" . req('hashed') . "\" />\n";
			$rewrite = 1;
		}
	}
	if (req('noform')) { $form .= "<input type=\"hidden\" name=\"noform\" value=\"" . req('noform') . "\" />\n"; }
	if (req('sort')) { $form .= "<input type=\"hidden\" name=\"sort\" value=\"" . req('sort') . "\" />\n"; }
	$comment = str_replace("<br />","|n|",$comment);
	if (req('noform')) {
		$hash['noform'] = req('noform');
	} elseif (req('edit')) {
		$hash['noform'] = req('edit');
	}
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if ($rewrite) {
		$input_del = "&nbsp;&nbsp;&nbsp;<input type=\"submit\" name=\"comment3_delete\" value=\"削除\">";
	} else {
		$input_del = '';
	}
	$help_link = "<div style=\"float:right;\"><a href=\"" . script_link($hash,'comment3') . "&amp;comment3_help=1#comment3_help\">ヘルプ</a>  <a href=\"" . script_link($hash,'comment3') . "&amp;comment3_admin=1#comment3pass$id\">管理者用</a></div>\n";
	$form .= "<div style=\"margin:0.3em;\"><input type=\"submit\" name=\"posted\" value=\"投稿\" />$input_del$help_link</div>\n";
	$form .= "<div style=\"display: flex;flex-wrap:wrap;\">\n";
	$form .= "<div style=\"margin:0.3em;\"><div>投稿者</div><div><input type=\"text\" name=\"writer\" value=\"" . $writer . "\" style=\"width:140px;\" /></div></div>\n";
	$form .= "<div style=\"margin:0.3em;\"><div>編集パスワード</div><div><input type=\"text\" name=\"password\" style=\"width:140px;\" /></div></div>\n";
	$form .= "</div>\n<div style=\"display: flex;flex-wrap:wrap;\">\n";
	$form .= "<div style=\"margin:0.3em;\">コメント <wbr><textarea name=\"comment\" cols=\"40\" rows=\"3\">$comment</textarea></div>\n";
//	if (!$rewrite) {
		$form .= "<div style=\"margin:0.3em;\"><div>添付</div><div><input type=\"file\" name=\"upfile\" value=\"\" /></div></div>\n";
//	}
	$form .= "</div>\n";

	$form .= "</form>\n";
	$form .= "</div>\n";
	$form = str_replace("\n","|n|",$form);
	$str = str_replace("\n","|n|",$str);
	$vars = get_defined_vars();
	
	if (!$order || $order == 'down') {
		$str .= $form;
	} elseif ($order == 'up') {
		$str = $form . $str;
	}
	return "<div id=\"comment3_top\">$str</div>\n";
}


function comment3_admin() {
	global $id, $id_dir, $str, $log, $id_path, $id, $img_ext;
	$login_time = 30;
	$mes = '';
	if (! file_exists($id_dir . '/comment3_login')) { mkdir($id_dir . '/comment3_login'); }
	$login_dir = $id_dir . '/comment3_login';
	$file_nmb = 1;
	while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
		$file_nmb++;
	}
	if (req('past_nmb')) {
		$past_nmb = req('past_nmb');
	} else {
		$past_nmb = $file_nmb - 1;
	}
	$past_path = preg_replace('/\.cgi$/','_' . $past_nmb . '.cgi',$id_path);
	if (req('show_past') && file_exists($past_path)) {
		$log = file($past_path);
		$log = array_reverse($log);
	}
	$file_list = array();
	$tmpdir = opendir($id_dir);
	while ($file = readdir($tmpdir)) {
		if (!preg_match('/^\.{1,2}$/',$file)) {
			$file_list[] = $file;
		}
	}
	closedir($tmpdir);
	$tmpdir = opendir($login_dir);
	while ($file = readdir($tmpdir)) {
		if (preg_match('/^\w{10}_/',$file) && filemtime($login_dir . '/' . $file) + 60 * $login_time < time()) {
			unlink($login_dir . '/' . $file);
		}
	}
	closedir($tmpdir);
	$hash = array();
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^comment3_admin/',$key)) { continue; }
		//if (preg_match('/^(comment_|mod_|del_|pass)/',$key)) { continue; }
		$hash[$key] = req($key);
	}
	$file_nmb = 1;
	while (file_exists(preg_replace('/\.cgi$/','_' . $file_nmb . '.cgi',$id_path))) {
		$file_nmb++;
	}
	if (req('past_nmb') && isset($past_path) && $past_path && file_exists($past_path)) {
		$id_path = $past_path;
	}
	$str .= "<a href=\"" . script_link($hash,'bbs') . "#comment3_top\">戻る</a>";
	$hash['comment3_admin'] = 1;
	if (req('comment3_admin_login')) {
		$hash['comment3_admin_login'] = req('comment3_admin_login');
		$str .= "  <a href=\"" . script_link($hash,'comment3') . "#comment3_top\">再読み込み</a>";
	}
	//$str .= "<div>\$id_path=$id_path</div>";
	if (!req('comment3_admin_login')) {
		if (! req('comment3_pass')) {
			$hash = array();
			foreach (array_keys($_REQUEST) as $key) {
				$hash[$key] = req($key);
			}
			$str .= script_form($hash,'comment3_top');
			if (isset($_COOKIE['comment3_admin_pass'])) {
				$cpass = $_COOKIE['comment3_admin_pass'];
			} else {
				$cpass = '';
			}
			$str .= "<input id=\"comment3pass$id\" type=\"password\" name=\"comment3_pass\" value=\"$cpass\" size=\"12\">";
			$str .= " <input type=\"submit\" name=\"comment3_login\" value=\"ログイン\">";
			$str .= "</form>\n";
			return "<div id=\"comment3_top\">$str</div>\n";
		} else {
			global $crypt_pass, $cookietime;
			if (decrypt(req('comment3_pass'), $crypt_pass) === 'no') {
				error("パスワードが認証できません");
			} else {
				$login_id = random_str(10);
				$comment3_admin_login = $hash['comment3_admin_login'] = $login_id;
				file_put_contents(join('/',array($login_dir, $login_id . '_' . $_SERVER['SERVER_NAME'] . '.cgi')),'',LOCK_EX);
				// クッキーの場合、エポック時間はどうなるのか？
				setcookie("comment3_admin_pass", req('comment3_pass'), time() + $cookietime * 3600 * 24);
			}
			$hash['comment3_pass'] = '';
		}
	} else {
		$login_path = join('/',array($login_dir, req('comment3_admin_login') . '_' . $_SERVER['SERVER_NAME'] . '.cgi'));
		$lhash = array('plugin'=>'comment3','id'=>req('id'),'noform'=>req('noform'),'sort'=>req('sort'),'comment3_admin'=>1);
		$relogin = script_link($lhash,'comment3');
		if (! file_exists($login_path) ) {
			error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin#comment3_top\">ログイン</a>");
		} else {
			if (filemtime($login_path) + 60 * $login_time < time()) {
				unlink($login_path);
				error("時間切れです。再度ログインしてください。&nbsp;<a href=\"$relogin#comment3_top\">ログイン</a>");
			} else {
				file_put_contents($login_path,'',LOCK_EX);
			}
		}
	}
	foreach (array_keys($_REQUEST) as $key) {
		if (preg_match('/^del_(\w+$)/',$key,$match)) {
			$del_id = $match[1];
			$new_log = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				if ($tmp[0] != $del_id) {
					$new_log[] = $line;
				} else {
					$mes .= '<div><strong>[' . $tmp[2] . ']</strong> の記事を削除しました。</div>';
				}
			}
			$log = $new_log;
			file_put_contents($id_path,$log,LOCK_EX);
			$del_files = preg_grep('/^' . $del_id . '/',$file_list);
			foreach ($del_files as $file) {
				if (unlink("$id_dir/$file")) {
					$mes .= '<div><strong>' . "$id_dir/$file" . '</strong> を削除しました。</div>';
				}
			}
			break;
		} elseif (preg_match('/^mod_(\w+$)/',$key,$match)) {
			$mod_id = $match[1];
			$new_log = array();
			foreach ($log as $line) {
				$tmp = explode('<>',$line);
				if ($tmp[0] == $mod_id) {
					$tmp[3] = req('comment_' . $mod_id);
					$tmp[3] = str_replace("\r\n","\n",$tmp[3]);
					$tmp[3] = str_replace("\r","\n",$tmp[3]);
					$tmp[3] = str_replace("\n",'<br />',$tmp[3]);
					$line = join('<>',$tmp);
					$mes .= '<strong>[' . $tmp[2] . ']</strong> の記事を修正しました。';
				}
				$new_log[] = $line;
			}
			$log = $new_log;
			file_put_contents($id_path,$log,LOCK_EX);
		}
	}
	if (!isset($comment3_admin_login) || !$comment3_admin_login) { $comment3_admin_login = req('comment3_admin_login'); }
	$hash = array('plugin'=>'comment3', 'id'=>$id, 'comment3_admin'=>1, 'comment3_admin_login'=>$comment3_admin_login);
	if (req('noform')) { $hash['noform'] = req('noform'); }
	if (req('sort')) { $hash['sort'] = req('sort'); }
	if (req('item')) { $hash['item'] = req('item'); }
	$indx = '';
	$hash_i = array('plugin'=>'comment3','id'=>$id,'past_nmb'=>'','comment3_admin'=>req('comment3_admin'),'comment3_admin_login'=>$comment3_admin_login);
	if (req('noform')) { $hash_i['noform'] = req('noform'); }
	if (req('sort')) { $hash_i['sort'] = req('sort'); }
	if (req('item')) { $hash_i['item'] = req('item'); }
	if (req('past_nmb')) {
		$link = script_link($hash_i);
		$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link#comment3_top\">現行ログ</a></div>\n";
	} else {
		$indx .= "<div style=\"padding:0.1em;\"><b>現行ログ</b></div>\n";
	}
	if (file_exists($past_path)) {
		$indx .= "<div style=\"padding:0.1em;\">　過去ログ</div>\n";
	}
	$nmb = 1;
	$show_next_id = 0;
	for ($i=$file_nmb-1; $i>=1; $i--) {
		if (req('past_nmb') && $i == req('past_nmb')) {
			$indx .= "<div style=\"padding:0.1em;\"><b>[$nmb]</b></div>\n";
		} else {
			$hash_i['past_nmb'] = $i;
			$hash_i['show_past'] = 1;
			//$link = script_link($hash_i) . "#next_page";
			$link = script_link($hash_i) . "#comment3_top";
			if (!$show_next_id) {
				$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link\" name=\"next_page\" id=\"next_page\">[" . $nmb . "]</a></div>\n";
				$show_next_id = 1;
			} else {
				$indx .= "<div style=\"padding:0.1em;\"><a href=\"$link\">[" . $nmb . "]</a></div>\n";
			}
		}
		$nmb++;
	}
	$str .= "<div style=\"display:flex;flex-wrap:wrap;\">$indx<div style=\"padding:0.1em;margin-left:auto;\">ログ数:" . count($log) . "</div>\n</div>";
	//$str .= "<div style=\"text-align:right;\">ログ数:" . count($log) . "</div>\n";
	$str .= "<div style=\"color:crimson\">$mes</div>\n";
	//$hash['show_spam'] = 0;
	$hash['comment3_admin'] = 1;
	//$hash['pass'] = req('pass');
	$hash['edit_ng'] = 0;
	if (req('comment3_admin_login')) { $hash['comment3_admin_login'] = req('comment3_admin_login'); }
	if (req('past_nmb')) { $hash['past_nmb'] = req('past_nmb'); }
	if (req('show_past')) { $hash['show_past'] = req('show_past'); }
	$hash['target_path'] = $id_path;
	$str .= script_form($hash);
	$str .= "<div>\n";
	$hash['comment3_admin'] = 1;
	$count = 0;
	foreach (array_reverse($log) as $line) {
		$count++;
		$tmp = explode('<>',$line);
		$aid = $tmp[0];
		$attach = preg_grep('/^' . $aid . '/',$file_list);
		if ($attach) {
			$test = join('<>',$attach);
		} else {
			$test = '';
		}
		$comment = $tmp[3];
		$comment = str_replace('<br />',"\n",$comment);
		if ($count % 2) {
			$backcol = "background-color:#dddddd;";
		} else {
			$backcol = "";
		}
		$str .= "<div style=\"display:flex;flex-wrap:wrap;align-items:flex-start;padding:0.2em;$backcol\">";
		$str .= "<div style=\"padding:0.2em;\"><textarea name=\"comment_" . $tmp[0] . "\" cols=\"40\" rows=\"2\" style=\"width:100%;\">" . $comment . "</textarea></div>";
		$str .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"mod_" . $tmp[0] . "\" value=\"修正\" style=\"font-size:80%;\"></div>";
		$hash['del_' . $tmp[0]] = 1;
		$str .= "<div style=\"padding:0.2em;\"><input type=\"submit\" name=\"del_" . $tmp[0] . "\" value=\"削除\" style=\"font-size:80%;\"></div>";
		$atc_str = '';
		foreach ($attach as $atc) {
			if (preg_match('/thumb\./',$atc) || preg_match('/\.(oname|count)$/',$atc)) {
				continue;
			}
			$oname_file = $atc . '.oname';
			if (in_array($oname_file,$file_list)) {
				$oname_path = "$id_dir/" . $oname_file;
				$oname = file_get_contents($oname_path,);
				$oname_str = " title=\"$oname\"";
			} else {
				$oname_str = $oname = '';
			}
			$ext = pathinfo($atc,PATHINFO_EXTENSION);
			if (in_array($ext,$img_ext) && !preg_match('/thumb\./',$atc)) {
				$thumb_file = preg_replace('/(\..{2,4}$)/','thumb$1',$atc);
				$thumb_path = "$id_dir/" . $thumb_file;
				if (in_array($thumb_file,$file_list)) {
				//if (file_exists($thumb_path)) {
					$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"$thumb_path\"$oname_str /></div>\n";
				} else {
					$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"$id_dir/$atc\"$oname_str /></div>\n";
				}
			} else {
				$atc_str .= "<div style=\"padding:0.1em;\"><img src=\"./img/clip.gif\"$oname_str /></div>\n";
			}
		}
		$str .= "<div style=\"display:flex;\">$atc_str</div>";
		$str .= "<div style=\"display:flex;flex-wrap:wrap; margin-left:auto;\"><div style=\"padding:0.2em;\">" . $tmp[2] . "</div><div style=\"font-size:80%;padding:0.2em;\">" . $tmp[1] . "</div></div>\n";
		unset($hash['del_' . $tmp[0]]);
		$str .= "</div>\n";
	}
	//$str .= "</table>\n";
	$str .= "</div>\n";
	$str .= "</form>\n";
	$str = str_replace("\n","|n|",$str);
	return "<div id=\"comment3_top\">$str</div>\n";
}


?>