<?php
$explan = '差分表示';
$format = "[[diff]]	// 引数を省略した場合は表記した記事自身の差分を表示
[[diff('メニューとトップページについて')]]	// 記事タイトルか記事IDを指定すると、その記事の差分を表示する
";

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function diff($option = '') {
	global $EGD_X, $EGD_Y, $EGD_XY, $EGD_END;
	global $datadir, $add_style, $del_style;
	if ($option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			if (strpos($_, '=') > 0) {
				list($key, $val) = explode('=',$_);
				if (isset($key) && isset($val)) { $option[$key] = $val; }
			} else {
				$id = $_;
			}
		}
	} else {
		unset($option);
	}
	if (!isset($id)) { $id = ''; }
	$add_style = 'background-color:#eeffff;color:#0044cc;';
	$del_style = 'background-color:#eeeeee;color:#666666;text-decoration:line-through';
	$EGD_X = 0;
	$EGD_Y = 1;
	$EGD_XY = 2;
	$EGD_END = 3;

	$str = '';
	if ($id && !preg_match('/^\w{10,16}$/',$id)) {
		$title = $id;
		$tmpdir = opendir($datadir);
		$id_list = array();
		while ($file = readdir($tmpdir)) {
			if (preg_match('/^(\w{8,16})\.cgi$/',$file)) {
				list($line) = file($datadir . '/' . $file);
				$tmp = explode('<>',$line);
				if (strpos($tmp[2],'&&') !== false) {
					$tmp2 = explode('&&',$tmp[2]);
				} else {
					$tmp2 = '';
				}
				if (isset($tmp[2]) && $tmp[2] == $title) {
					$id_list[] = $tmp[0];
				} elseif ($tmp2) {
					foreach ($tmp2 as $_) {
						if ($_ == $title) {
							$id_list[] = $tmp[0];
							break;
						}
					}
				}
			}
		}
		closedir($tmpdir);
		if (!$id_list) {
			$str .= "<div><strong>" . $title . "</strong>は見つかりません</div>\n";
		} else {
			foreach ($id_list as $id) {
				$str .= show_diff($id);
			}
		}
	} else {
		if (! $id) { $id = article_id(); }
		$str .= show_diff($id);
	}
	return $str;
}



function show_diff($id) {
	$backup_list = $file_list = array();
	$dir = article_dir($id);
	if (is_dir($dir)) {
		$tmpdir = opendir($dir);
		while ($file = readdir($tmpdir)) {
			if (preg_match('/^(\d{10})\.cgi$/',$file,$matched)) {
				$backup_list[] = $matched[1];
				$file_list[] = $file;
			}
		}
		closedir($tmpdir);
	}
	rsort($backup_list);
	rsort($file_list);
	$str = $log = $bef_log = $title = '';
	if (file_exists($dir . '.cgi')) {
		list($line) = file($dir . '.cgi');
		list($dm,$dm,$title,$dm) = explode('<>',$line);
	}
	
	// 差分を表示する場合
	if (req('show') && req('id') == $id && req('backup')) {
		list($line) = file(req('backup'));
		$tmp = explode('<>',$line);
		if (isset($tmp[4])) { $log = $tmp[4]; }
		if (preg_match('/\d{10}\.cgi$/',req('backup'))) {
			$count = 0;
			foreach ($file_list as $file) {
				if (strpos(req('backup'),$file) !== false) {
					$count++;
					break;
				}
				$count++;
			}
			if (isset($file_list[$count])) {
				list($line) = file($dir . '/' . $file_list[$count]);
				$tmp = explode('<>',$line);
				if (isset($tmp[4])) { $bef_log = $tmp[4]; }
			}
		} else {
			list($line) = file($dir . '/' . $file_list[0]);
			$tmp = explode('<>',$line);
			if (isset($tmp[4])) { $bef_log = $tmp[4]; }
		}
		//$str1 = explode('<br />',$log);
		$str1 = preg_split('/(<br \/>|\/n\/)/',$log);
		//$str2 = explode('<br />',$bef_log);
		$str2 = preg_split('/(<br \/>|\/n\/)/',$bef_log);
		$new_str1 = $new_str2 = array();
		foreach ($str1 as $s1) {
			$s1 = str_replace('<','&lt;',$s1);
			$new_str1[] = $s1;
		}
		foreach ($str2 as $s2) {
			$s2 = str_replace('<','&lt;',$s2);
			$new_str2[] = $s2;
		}
		$diff = execDiff($new_str1,$new_str2);
		$diff = str_replace('/n/','<br />',$diff);
	}
	foreach ($backup_list as $backup) {
		$sele = '';
		if (req('backup') ==  $dir . '/' . $backup . ".cgi") { $sele = " selected=\"selected\""; }
		$str .= "<option$sele value=\"" . $dir . '/' . $backup . ".cgi\">" . date("Y/m/d H:i:s",$backup) . "</option>\n";
	}
	if ($str) {
		$hash = array('plugin'=>'diff','id'=>$id);
		if (req('noform')) { $hash['noform'] = req('noform'); }
		if (req('sort')) { $hash['sort'] = req('sort'); }
		$form = script_form($hash,'diff');
		$sele = '';
		if (!req('backup') || req('backup') ==  $dir . '.cgi') { $sele = " selected=\"selected\""; }
		$str_d = "<option$sele value=\"" . $dir . '.cgi' . "\">" . '最新記事' . "</option>\n";
		$hash = array('noform'=>$id);
		$link = script_link($hash);
		$box_size = count($backup_list) + 1;
		if ($box_size > 10) { $box_size = 10; }
		$str = "\n" . $form . "<input id=\"diff\" type=\"submit\" name=\"show\" value=\"表示\"><br /><strong><a href=\"$link\">$title</a></strong>の差分<br />\n" . "<select name=\"backup\" size=\"" . $box_size . "\">\n" . $str_d . $str . "</select>\n</form>\n";
	}
	if (isset($diff) && $diff) { $str .= diff_help() . "<div style=\"border: 1px dashed #000000;padding:0.5em;\">\n" . join('<br />',$diff) . "</div>\n"; }
	$str = str_replace("\n",'|n|',$str);
	if (! $str) {
		$hash = array('noform'=>$id);
		$link = script_link($hash);
		$str .= "<strong><a href=\"$link\">$title</a></strong>の差分はありません。";
	}
	$str = "<div style=\"margin:0.5em;\">\n$str</div>\n";
	return $str;
}


function diff_help() {
	global $add_style, $del_style;
	$str = '
	<div>
	<ul>
	<li>変更部分は<span style="' . $add_style . '">青</span>で表示
	<li>削除された部分は<span style="' . $del_style . '">グレー</span>で表示
	</ul>
	</div>';
	$str = str_replace("\t",'',$str);
	$str = str_replace("\n",'|n|',$str);
	return $str;
}



function makeEditGraph($str1, $str2) {
	global $EGD_X, $EGD_Y, $EGD_XY, $EGD_END;
	$edit_graph = array();

	$edit_graph[count($str1)] = array();
	$edit_graph[count($str1)][count($str2)]['cost'] = 0;
	$edit_graph[count($str1)][count($str2)]['direction'] = $EGD_END;
 
	for ( $x = (count($str1) - 1); 0 <= $x; $x--) {
		$edit_graph[$x] = array();
		$edit_graph[$x][count($str2)]['cost'] = (count($str1) - $x);
		$edit_graph[$x][count($str2)]['direction'] = $EGD_X;
	}
	for ( $y = (count($str2) - 1); 0 <= $y; $y--) {
		$edit_graph[count($str1)][$y]['cost'] = (count($str2) - $y);
		$edit_graph[count($str1)][$y]['direction'] = $EGD_Y;
	}
 
	for ( $x = (count($str1) - 1); 0 <= $x; $x--) {
		for ( $y = (count($str2) - 1); 0 <= $y; $y--) {
			$cost;
			$direction;
			if (isset($edit_graph[($x+1)][$y]['cost']) && isset($edit_graph[$x][($y+1)]['cost']) && $edit_graph[($x+1)][$y]['cost'] <= $edit_graph[$x][($y+1)]['cost']) {
				$cost = $edit_graph[($x+1)][$y]['cost'];
				$direction = $EGD_X;
			} else {
				$cost = $edit_graph[$x][($y+1)]['cost'];
				$direction = $EGD_Y;
			}

			if(($str1[$x] == $str2[$y]) && (isset($edit_graph[($x+1)][($y+1)]['cost']) && $edit_graph[($x+1)][($y+1)]['cost'] <= $cost)) {
				$cost = $edit_graph[($x+1)][($y+1)]['cost'];
				$direction = $EGD_XY;
			}

			$edit_graph[$x][$y]['cost'] = $cost+1;
			$edit_graph[$x][$y]['direction'] = $direction;
		}
	}
	return $edit_graph;
}


function getDiffString($str1, $str2) {
	global $EGD_X, $EGD_Y, $EGD_XY, $EGD_END;
	$edit_graph = makeEditGraph($str1, $str2);
	$x = 0;
	$y = 0;
 
	$diff_string = array();
	while (($x < count($str1)) || ($y < count($str2))) {
		switch($edit_graph[$x][$y]['direction']) {
			case $EGD_X:
				$diff_string[] = plus_ch($str1[$x]);
				$x++;
				break;
			case $EGD_Y:
				$diff_string[] = minus_ch($str2[$y]);
				$y++;
				break;
			case $EGD_XY:
				$diff_string[] = $str1[$x];
				$x++;
				$y++;
				break;
		}
	}
	return $diff_string;
}


function execDiff($str1,$str2) {
	$diff_string = getDiffString($str1, $str2);
	return $diff_string;
}

function minus_ch($ch) {
	global $del_style;
	return '<span style="' . $del_style . '">' . $ch . '</span>';
}
 
function plus_ch($ch) { 
	global $add_style;
	return '<span style="' . $add_style . '">' . $ch . '</span>';

}



?>