<?php
$explan = '記事の入力ルールを簡単に説明します';	// プラグインの説明を記述
$format = '[[help]]';	// プラグインの呼び出し例

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function help() {
	$str = '基本的にテキスト装飾はhtmlのタグで直接記述します。管理者設定で許可されたタグが使用できます。
<h1>タイトル</h1>
同じ記事を複数のタイトルで探せるようにしたい場合、複数のタイトルをつけることをできます。
たとえば、同じ記事に「MACアドレス」「物理アドレス」両方の名前をつけるには、タイトルに
<pre>
MACアドレス&&物理アドレス
</pre>
と入力します。こうすると、それぞれの名前で記事を探すことができます。
記事では最初に記入した名前がタイトルとして表示され、2番目以降が別名として表記されます。
インデックス上ではそれぞれの名前が表示されます。<br />
また、タイトルが同じで内容が違う記事を複数登録することもできます。
<h1>カテゴリー</h1>
カテゴリー欄に入力すると、カテゴリーが設定されます。新たなカテゴリーを入力すると、次回からそのカテゴリーをリストから選択することができます。
カテゴリーを指定すると、カテゴリーごとに記事を表示したり、カテゴリーによる記事の絞り込みができます。<br />
ひとつの記事に複数のカテゴリーを指定することができます。カテゴリー欄に
<pre>コンピュータ&&ソフトウェア</pre>
のように"&&"で区切って入力すると、「コンピュータ」「ソフトウェア」2つのカテゴリーを指定したことになります。
<h1>見出し</h1>
見出しはh1、... h4タグを使うことを想定しています。見た目の変更はstyle.cssで行うことになります。
<pre>
&lt;h1&gt;h1タグによる見出し&lt;/h1&gt;
&lt;h2&gt;h2タグによる見出し&lt;/h2&gt;
&lt;h3&gt;h3タグによる見出し&lt;/h3&gt;
&lt;h4&gt;h4タグによる見出し&lt;/h4&gt;
</pre>
<h1>h1タグによる見出し</h1>
<h2>h2タグによる見出し</h2>
<h3>h3タグによる見出し</h3>
<h4>h4タグによる見出し</h4>
<|>
<h1>タグ</h1>
許可されているタグは、編集フォームの「使用可能なタグ」で確認できます。
許可されたタグは文字参照で記述しても有効になるので、ご注意ください。

&lt;abc&gt;ABC&lt;/abc&gt;のように登録されていないタグは文字参照で表示されます。<br />
preタグ内では許可されているタグを含めてすべてのタグが文字参照で表示されます。
<pre>
&lt;div style="color:red;"&gt;許可されているタグ&lt;/div&gt;
&lt;font style="color:blue;"&gt;許可されていないタグ&lt;/font&gt;
&lt;abc&gt;許可されていないタグ&lt;/abc&gt;
</pre>
同じものをpreタグの外に出すと
<div style="color:red;">許可されているタグ</div>
&lt;font style="color:blue;"&gt;許可されていないタグ&lt;/font&gt;
&lt;abc&gt;許可されていないタグ&lt;/abc&gt;

<|><h1>改行</h1>
<pre>「改行を&lt;br /&gt;に変換する」</pre>をチェックしていると、フォーム中の改行を<pre>&lt;br /&gt;</pre>
に変換して記事の改行に反映させます。ただし、行の最後が閉じタグ "&gt;" あるいはプラグインの記述に使う "]]" の場合は変換されません。
<pre>
&lt;table&gt;
&lt;tr&gt;&lt;td&gt;テーブル&lt;/td&gt;&lt;/tr&gt;
&lt;/table&gt;
</pre>
が
<pre>
&lt;table&gt;&lt;br /&gt;
&lt;tr&gt;&lt;td&gt;テーブル&lt;/td&gt;&lt;/tr&gt;&lt;br /&gt;
&lt;/table&gt;&lt;br /&gt;
</pre>
のようになると変だからです。

<|><h1>部分編集</h1>
部分編集することができます。
部分編集したい部分に
<pre>&lt;|&gt;</pre>
を挿入してください。
その場所から次のマーク部分までだけを編集することができます。
記事が長くて編集か所を見つにくいときなどに使用してください。<|>
<h1>添付ファイル</h1>
画像などの添付ファイルは記事ごとにアップロードします。<br />
「投稿」ボタンを押してファイルをアップロードすると、ファイルのサムネールの上にそのファイルの埋め込みタグが表示されるので、それをコピーして貼り付けます。<br />
画像ファイルの場合、imgタグにwidth属性を指定しますが、オリジナルの画像の幅となっています。大きすぎてはみ出すような場合は、適当な数値に変更してください。<br />
<br />
添付ファイルは記事ごとに管理されますが、埋め込みタグは記事に関連づけられたディレクトリへ保存されたファイルのパスを指定しているだけなので、他の記事に埋め込んでもそのまま使えます。
<h1>スキン</h1>
見た目の変更はテンプレートのHTMLファイルとCSSファイルで行います。<br />
<br />
管理者設定ページで選択したスキンファイルと同名のCSSファイルが使用されます。<br />
たとえばスキンとして./tmpl/basic.htmlを選択した場合、./tmpl/basic.cssというファイルが存在すれば、それが./style.cssにコピーされて実際に使用されるCSSファイルとなります。また./tmpl/basic_print.cssというファイルが存在すれば、それが./print.cssにコピーされて実際に使用される印刷用CSSファイルとなります。<br />
HTMLファイルと同名のCSSファイルがなければ、./tmpl/style.cssや./tmpl/print.cssがコピーされます。<br />
<br />
このため、直接./style.css、./print.cssを編集した場合は、管理者設定画面で設定を変更した際に./tmplディレクトリ内のCSSファイルで上書きされてしまうのご注意ください。';
	
	list($midashi_str,$preview_comment,$midashi) = midashi($str,article_id());
	$preview_str = '';
	if ($midashi) {
		foreach (array_keys($midashi) as $key) {
			$midashi[$key] = preg_replace('/(<h[1234])/','$1 id="midashi' . article_id() . $key . '"',$midashi[$key]);
			$preview_comment = str_replace('<midashi' . $key . '>',$midashi[$key],$preview_comment);
		}
	}
	if (isset($midashi_str) && $midashi_str) {
		$count = 0;
		$tmp = "<div class=\"outline\"><div onclick=\"obj=document.getElementById('open" . $count . "').style; obj.display=(obj.display=='none')?'block':'none';\"><a style=\"cursor:pointer;\">アウトライン</a></div>\n";
		$midashi_str = "$tmp<div id=\"open" . $count . "\" style=\"display:none;clear:both;\">$midashi_str</div>\n</div>\n";
		$preview_str .= "$midashi_str$preview_comment\n";
	} else {
		$preview_str .= "$preview_comment\n";
	}
	$preview_str = str_replace(array("\r\n","\r","\n"), '|n|', $preview_str);
	return $preview_str;
}


?>