<?php
$explan = "記事の一覧を表示する
<h3>指定できるオプション</h3>
<dl><dt>ptn</dt><dd>正規表現で絞り込む
例　[[listup('ptn=/^\w{3}/')]]</dd></dl>
<dl><dt>category</dt><dd>カテゴリーで絞り込む</dd></dl>
<dl><dt>type</dt><dd>今のところtype=tableでテーブル表示にする場合のみ使用</dd></dl>
<dl><dt>nmb</dt><dd>表示件数</dd></dl>
<dl><dt>sort</dt><dd>ソート方法sort=name(名前順) sort=time(新しい順)</dd></dl>
<dl><dt>length</dt><dd>記事名が長い場合省略</dd></dl>
";	// プラグインの説明を記述
$format = "
[[listup]]			// すべて表示
[[listup('ptn=/^\w{5}/')]]			// 正規表現で絞り込む場合
[[listup('category=Perl')]]			// カテゴリーで絞り込む場合
[[listup('ptn=/^\d/|type=table')]]			// テーブルで表示
[[listup('nmb=20|sort=time')]]			// 表示件数を指定 時間順にソート
[[listup('nmb=20|length=20')]]			// 記事名が長い場合省略
";

////////////////////////////////////////////////////////
// article_id()			記事のIDを取得
// article_dir($id)		記事用ディレクトリ
// tag_convert($html)	指定タグ以外を無効化
// week_name($year,$month,$day)	年月日から曜日を取得
// get_holiday($year,$month,$day)	祝日を取得
////////////////////////////////////////////////////////

function listup($option = '') {	//$ptn = '', $category = '', $sort = '', $type = '', $nmb = '', $length = ''
	global $show_new, $new_day,$current_time,$req,$admin_back_color, $admin_pass_name, $current_back_color;
	if ($option) {
		$tmp = explode('|',$option);
		$option = array();
		foreach ($tmp as $_) {
			$tmp2 = explode('=',$_);
			if (isset($tmp2[0]) && isset($tmp2[1])) { $option[$tmp2[0]] = $tmp2[1]; }
		}
	} else {
		unset($option);
	}
	if (! isset($option['category'])) { $option['category'] = ''; }
	if (! isset($option['ptn'])) { $option['ptn'] = ''; }
	if (! isset($option['sort'])) { $option['sort'] = ''; }
	if (! isset($option['type'])) { $option['type'] = ''; }
	if (! isset($option['nmb'])) { $option['nmb'] = ''; }
	if (! isset($option['length'])) { $option['length'] = ''; }
	if (! isset($option['page_max'])) { $option['page_max'] = 40; }
	$tms = array();
	$tmpdir = opendir('./data');
	while ($file = readdir($tmpdir)) {
		if (preg_match('/^\.{1,2}$/',$file)) { continue; }
		$path = './data/' . $file;
		if (is_file($path)) {
			list($log) = file($path,FILE_IGNORE_NEW_LINES);
			$tmp = explode('<>',$log);
			list($id,$tm,$title,$cat,$article,$ip) = $tmp;
			if (isset($tmp[6])) { $lock[$id] = $tmp[6]; } else { $lock[$id] = ''; }
			if (isset($tmp[7])) { $amode[$id] = $tmp[7]; } else { $amode[$id] = ''; }
			$tr_style = '';
			$cat_ = explode('&&',$cat);
			if ($option['category']) {
				$hit = 0;
				foreach ($cat_ as $_) {
					if ($_ == $option['category']) {
						$hit = 1;
						break;
					}
				}
				if (!$hit) { continue; }
			}
			$alias = explode('&&',$title);
			if ($option['ptn']) {
				$hit = 0;
				if (preg_match('|^/.*/$|',$option['ptn'])) {
					foreach ($alias as $al) {
						if (preg_match($option['ptn'],$al)) {
							$hit = 1;
							break;
						}
					}
				} else {
					foreach ($alias as $al) {
						if (strpos($al,$option['ptn']) !== false) {
							$hit = 1;
							break;
						}
					}
				}
				if (!$hit) { continue; }
			}
			
			$titles[$id] = $title;
			$tms[$id] = $tm;
			$categorys[$id] = $cat;
			//$articles[$id] = $article;
		}
	}
	closedir($tmpdir);
	$alart = '';
	if ($option['sort'] == 'time' || $option['sort'] == 'new' && isset($tms)) {
		arsort($tms);
		$key_list = array_keys($tms);
	} elseif ($option['sort'] == 'old') {
		asort($tms);
		$key_list = array_keys($tms);
	} elseif (!$option['sort'] || $option['sort'] == 'name') {
		if (isset($titles)) {
			asort($titles);
			$key_list = array_keys($titles);
		} else {
			$key_list = array();
		}
	} else {
		$alart .= "<div style=\"color:crimson;\">sort=" . $option['sort'] . "は無効な設定です。使用できるのはtime new old nameです</div>";
		$key_list = array_keys($tms);
	}
	if ($option['nmb']) {
		$break_ = $option['nmb'];
		$key_list = array_slice($key_list,0,$option['nmb']);
	}

	$lists = '';
	$page = 0;
	if (req('listup_page')) {
		$page = req('listup_page');
	}
	$max = $option['page_max'];
	$index = '';
	$filterd_key_list = array();
	$admin_mode = '';
	if (isset($_COOKIE[$admin_pass_name]) && $_COOKIE[$admin_pass_name]) { $admin_mode = 1; }
	foreach ($key_list as $key) {
		if ($admin_mode || !isset($amode[$key]) || !$amode[$key]) {
			$filterd_key_list[] = $key;
		}
	}
	$key_list = $filterd_key_list;
	if (count($key_list) > $max) {
		for($i=0; $i <= intval((count($key_list)-1)/$max); $i++) {
			$hash = array('plugin'=>'listup','listup_page'=>$i);
			if (req('noform')) { $hash['noform'] = req('noform'); }
			if ($req['sort']) { $hash['sort'] = $req['sort']; }
			$link = script_link($hash) . "#plugin_listup";
			if ($i != $page) {
				if ($i == 0) {
					$index .= "<a href=\"$link\" name=\"plugin_listup\" id=\"plugin_listup\">$i</a> ";
				} else {
					$index .= "<a href=\"$link\">$i</a> ";
				}
			} else {
				$index .= "<b>$i</b> ";
			}
		}
	}
	$count = -1;
	foreach ($key_list as $key) {
		$tr_style = '';
		$class = 'list';
		if (isset($amode[$key]) && $amode[$key]) {
			if (!$admin_mode) {
				continue;
			} else {
				$class = 'amode';
				$tr_style = " style=\"background-color:$admin_back_color;\"";
			}
		}
		if ($key == req('noform')) {
			$class = 'current';
			$tr_style = " style=\"background-color:$current_back_color;\"";
		} elseif ($key == req('edit')) {
			$class = 'edit_mode';
		}
		if ($class) { $class = " class=\"$class\""; }
		$count++;
		if ($max < count($key_list) && intval($count / $max) != $page) {
			continue;
		}
		$alias = explode('&&',$titles[$key]);
		$hash = array('noform'=>$key,'sort'=>$req['sort']);
		$link = script_link($hash);
		foreach ($alias as $al) {
			$new = '';
			$title = '';
			if ($option['length'] && mb_strwidth($al) > $option['length']) {
				$title = " title=\"$al\"";
				$al = mb_strimwidth($al,0,$option['length']) . '...';
			}
			if (gettype($tms[$key]) == 'integer') {
				if ($show_new && time() - $tms[$key] < $new_day*3600*24) {
					$new = "<span style=\"color:crimson;font-size:80%;\">new</span>&nbsp;";
				}
			} else {
				$epc = strtotime($tms[$key]);
				$cur_epc = strtotime($current_time);
				if ($show_new && $cur_epc - $new_day*3600*24 < $epc) {
					$new = "<span style=\"color:crimson;font-size:80%;\">new</span>&nbsp;";
				}
			}
			if ($option['ptn']) {
				//$lists .= "<tr$tr_style><td>$new<a href=\"$link\"$title>$al</a>&nbsp;";
//					$lists .= "<tr$class><td style=\"vertical-align:center;\">$new<a href=\"$link\"$title>$al</a>&nbsp;";
//					$lists .= "<span style=\"font-size:80%;\">" . date2("Y/m/d H:i:s",$tms[$key]) . "</span></td></tr>\n";
				$lists .= "<div$class style=\"display:flex;flex-wrap:wrap;justify-content:space-between;align-items:center;\">";
				$lists .= "<div style=\"vertical-align:center;\">$new<a href=\"$link\"$title>$al</a>  </div>";
				$lists .= "<div style=\"font-size:80%;margin-left:auto;\">" . date2("Y/m/d H:i:s",$tms[$key]) . "</div>";
				$lists .= "</div>\n";
			} else {
				$lists .= "<div$class style=\"display:flex;flex-wrap:wrap;justify-content:space-between;align-items:center;\">";
				$lists .= "<div>$new<a href=\"$link\"$title>$al</a>  </div>";
				$lists .= "<div style=\"font-size:80%;margin-left:auto;\">" . date2("Y/m/d H:i:s",$tms[$key]) . "</div>\n";
				$lists .= "</div>\n";
			}
		}
	}
	if ($lists) {
		$lists = "$index\n$lists\n";
//		if ($option['type'] == 'table') {
//			$lists = "$index\n<table>$lists</table>\n";
//		} else {
//			$lists = "$index\n<ul>$lists</ul>\n";
//		}
	}
	$lists = str_replace("\n","/n/",$lists);
	return $alart . $lists;
}


?>